package za.co.momentum.recurring.client.thread.services;

import za.co.momentum.recurring.client.thread.ThreadListenerIFace;

/**
 * This is an interface class responsible for handling all service actions.
 * Look at the ServiceAction abstract class. This class implements this interface and
 * all service actions must implement ServiceAction class.
 * 
 * @author Deon van Aarde
 * Momentum Risk & Savings
 * Created on 2005/08/30
 */
public interface ServiceThreadIFace  {
	
	/**
	 * Method which must be implemented. It will add a ThreadListenerIFace.
	 * @param aListener
	 */
	public void addThreadListener(ThreadListenerIFace aListener);
	
	/**
	 * Method which must be implemented. It will remove a ThreadListenerIFace.
	 * @param aListener
	 */
	public void removeThreadListener(ThreadListenerIFace aListener);
	
	/**
	 * Method for starting the thread.
	 *
	 */
	public void start();
	
}