package za.co.momentum.recurring.nurse.client.model;

import java.io.Serializable;
import java.util.Date;

import za.co.momentum.risk.fastlane.nurse.dto.UserTO;

public class User implements Serializable {
	
	private static final long serialVersionUID = -3563632582630482375L;
	
	private String username;
	private String password;
	private Date lastLogin;
	private UserTO userTO;

	public User(final UserTO userTO) {
		this.userTO = userTO;
		this.username = userTO.getUsername();
		this.password = userTO.getPassword();
		this.lastLogin = new Date();
	}
	
	public User(final String username, final String password) {
		this.username = username;
		this.password = password;
		this.lastLogin = new Date();
	}

	public String getUsername() {
		return username;
	}
	
	public void setUsername(String username) {
		this.username = username;
	}
	
	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
	
	public Date getLastLogin() {
		return lastLogin;
	}
	
	public void setLastLogin(Date lastLogin) {
		this.lastLogin = lastLogin;
	}
	
	public UserTO getUserTO() {
		return userTO;
	}
	
	public void setUserTO(UserTO userTO) {
		this.userTO = userTO;
	}
}
