package za.co.momentum.recurring.nurse.client.ui;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.PlatformUI;

import za.co.momentum.recurring.nurse.client.model.ClientWindowManager;
import za.co.momentum.recurring.nurse.client.model.ErrMessage;
import za.co.momentum.recurring.nurse.client.tools.PdfFileManager;
import za.co.momentum.risk.fastlane.nurse.dto.EFormTO;
import za.co.momentum.recurring.nurse.util.FastlaneFormBackup;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation, company or business for any purpose whatever) then
 * you should purchase a license for each developer using Jigloo. Please visit www.cloudgarden.com for details. Use of
 * Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS MACHINE, SO
 * JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class FormBackupManager extends org.eclipse.swt.widgets.Dialog {

  private Shell dialogShell;

  private Button cmdSaveFormAs;

  private Button cmdCancel;

  private Composite cmdArea;

  private TableColumn tcImageName;

  private Table backupFileTable;

  EFormTO[] eforms;
  private Button allForms;
  private Button last30Days;
  private Composite compositeTop;

  private Button cmdRestoreForm;

  private TableColumn tMcode;

  private TableColumn tRow;

  private TableColumn tDateCreated;

  private TableColumn tLifeAssured;

  private TableColumn tPolNo;

  private FastlaneFormBackup fastlaneFormBackup = null;

  /**
   * Auto-generated main method to display this org.eclipse.swt.widgets.Dialog inside a new Shell.
   */
  public static void main(String[] args) {
    try {
      Display display = Display.getDefault();
      Shell shell = new Shell(display);
      FormBackupManager inst = new FormBackupManager(shell, SWT.NULL);
      inst.open();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public FormBackupManager(Shell parent, int style) {
    super(parent, style);
    fastlaneFormBackup = new FastlaneFormBackup();
  }

  public void open() {
    try {
      Shell parent = getParent();
      dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);

      dialogShell.setLayout(new GridLayout());
      dialogShell.layout();
      dialogShell.pack();
      dialogShell.setSize(935, 522);
      dialogShell.setText("Fastlane EForms Backup Manager");
      {
        compositeTop = new Composite(dialogShell, SWT.NONE);
        GridLayout compositeTopLayout = new GridLayout();
        compositeTopLayout.makeColumnsEqualWidth = true;
        GridData compositeTopLData = new GridData();
        compositeTopLData.widthHint = 657;
        compositeTopLData.heightHint = 47;
        compositeTop.setLayoutData(compositeTopLData);
        compositeTop.setLayout(compositeTopLayout);
        {
          last30Days = new Button(compositeTop, SWT.RADIO | SWT.LEFT);
          last30Days.setText("Show only forms of the last 30 days");
          last30Days.setSelection(true);
          last30Days.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
              last30DaysWidgetSelected(evt);
            }
          });
        }
        {
          allForms = new Button(compositeTop, SWT.RADIO | SWT.LEFT);
          GridData allFormsLData = new GridData();
          allFormsLData.widthHint = 338;
          allFormsLData.heightHint = 16;
          allForms.setLayoutData(allFormsLData);
          allForms.setText("Show all available forms (last 90 days in backup folder)");
          allForms.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
              allFormsWidgetSelected(evt);
            }
          });
        }
      }
      {
        backupFileTable = new Table(dialogShell, SWT.FULL_SELECTION | SWT.BORDER);
        GridData imageTableLData = new GridData();
        imageTableLData.horizontalAlignment = GridData.FILL;
        imageTableLData.grabExcessHorizontalSpace = true;
        imageTableLData.grabExcessVerticalSpace = true;
        imageTableLData.verticalAlignment = GridData.FILL;
        backupFileTable.setLayoutData(imageTableLData);
        backupFileTable.setLinesVisible(true);
        backupFileTable.setHeaderVisible(true);
        backupFileTable.addMouseListener(new MouseAdapter() {
          public void mouseDoubleClick(MouseEvent evt) {
            imageTableMouseDoubleClick(evt);
          }
        });
        {
          tRow = new TableColumn(backupFileTable, SWT.NONE);
          tRow.setWidth(2);
        }
        {
          tcImageName = new TableColumn(backupFileTable, SWT.NONE);
          tcImageName.setText("Backup Date");
          tcImageName.setWidth(120);
        }
        {
          tPolNo = new TableColumn(backupFileTable, SWT.NONE);
          tPolNo.setText("Policy Number");
          tPolNo.setWidth(90);
        }
        {
          tLifeAssured = new TableColumn(backupFileTable, SWT.NONE);
          tLifeAssured.setText("Client Name");
          tLifeAssured.setWidth(200);
        }
        {
          tLifeAssured = new TableColumn(backupFileTable, SWT.NONE);
          tLifeAssured.setText("Client Number");
          tLifeAssured.setWidth(100);
        }
        {
          tMcode = new TableColumn(backupFileTable, SWT.NONE);
          tMcode.setText("EForm File Name");
          tMcode.setWidth(190);
        }
        {
          tDateCreated = new TableColumn(backupFileTable, SWT.NONE);
          tDateCreated.setText("Backup File Name");
          tDateCreated.setWidth(190);
        }
      }
      {
        cmdArea = new Composite(dialogShell, SWT.NONE);
        GridLayout cmdAreaLayout = new GridLayout();
        cmdAreaLayout.numColumns = 3;
        cmdArea.setLayout(cmdAreaLayout);
        GridData cmdAreaLData = new GridData();
        cmdAreaLData.heightHint = 43;
        cmdAreaLData.horizontalAlignment = GridData.CENTER;
        cmdAreaLData.grabExcessHorizontalSpace = true;
        cmdAreaLData.widthHint = 372;
        cmdArea.setLayoutData(cmdAreaLData);
        {
          cmdSaveFormAs = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
          GridData cmdViewLData = new GridData();
          cmdViewLData.heightHint = 31;
          cmdViewLData.horizontalAlignment = GridData.CENTER;
          cmdViewLData.widthHint = 93;
          cmdSaveFormAs.setLayoutData(cmdViewLData);
          cmdSaveFormAs.setText("Save Form As...");
          cmdSaveFormAs.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
              saveEFormButtonSelected(evt);
            }
          });
        }
        {
          cmdRestoreForm = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
          GridData cmdRestoreFormLData = new GridData();
          cmdRestoreFormLData.heightHint = 31;
          cmdRestoreFormLData.horizontalAlignment = GridData.END;
          cmdRestoreFormLData.widthHint = 168;
          cmdRestoreForm.setLayoutData(cmdRestoreFormLData);
          cmdRestoreForm.setText("Restore Form To Work Folder");
          cmdRestoreForm.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
              cmdRestoreFormWidgetSelected(evt);
            }
          });
        }
        {
          cmdCancel = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
          GridData cmdCancelLData = new GridData();
          cmdCancelLData.heightHint = 31;
          cmdCancelLData.widthHint = 93;
          cmdCancel.setLayoutData(cmdCancelLData);
          cmdCancel.setText("Close");
          cmdCancel.addMouseListener(new MouseAdapter() {
            public void mouseDown(MouseEvent evt) {
              cmdCancelMouseDown(evt);
            }
          });
        }
      }
      dialogShell.open();

      // Add popup menu
      Menu popupMenu = new Menu(backupFileTable);
      MenuItem saveImageAs = new MenuItem(popupMenu, SWT.PUSH);
      saveImageAs.setText("Save form as...");
      saveImageAs.addSelectionListener(new MenuItemListener());
      MenuItem separatorItem = new MenuItem(popupMenu, SWT.SEPARATOR);
      MenuItem resendImageToAWD = new MenuItem(popupMenu, SWT.PUSH);
      resendImageToAWD.setText("Restore form to client's work folder");
      resendImageToAWD.addSelectionListener(new MenuItemListener());

      backupFileTable.setMenu(popupMenu);

      loadTableDefault();

      Display display = dialogShell.getDisplay();
      while (!dialogShell.isDisposed()) {
        if (!display.readAndDispatch())
          display.sleep();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

  }

  private void cmdCancelMouseDown(MouseEvent evt) {
    dialogShell.close();
  }

  private void loadTableDefault() {
    
    backupFileTable.clearAll();
    backupFileTable.setItemCount(0);

    // Get all available Fastlane EForm backup files
    //Map backupFileDescriptors = fastlaneFormBackup.getAllBackupFileDescriptors();
    Map backupFileDescriptors = fastlaneFormBackup.getBackupFileDescriptorsOfLastXDays(30);

    // Now iterate through the map populating the table
    Iterator entries = backupFileDescriptors.entrySet().iterator();
    while (entries.hasNext()) {
      Entry thisEntry = (Entry) entries.next();
      String fileName = (String) thisEntry.getKey();
      String backupFileDescriptor = (String) thisEntry.getValue();
      addDescriptorToTable(backupFileDescriptor, fileName);
    }
  }
  
  private void loadTableAll() {
    
    backupFileTable.clearAll();
    backupFileTable.setItemCount(0);

    // Get all available Fastlane EForm backup files
    Map backupFileDescriptors = fastlaneFormBackup.getAllBackupFileDescriptors();
    //Map backupFileDescriptors = fastlaneFormBackup.getBackupFileDescriptorsOfLastXDays(31);

    // Now iterate through the map populating the table
    Iterator entries = backupFileDescriptors.entrySet().iterator();
    while (entries.hasNext()) {
      Entry thisEntry = (Entry) entries.next();
      String fileName = (String) thisEntry.getKey();
      String backupFileDescriptor = (String) thisEntry.getValue();
      addDescriptorToTable(backupFileDescriptor, fileName);
    }
  }

  private void addDescriptorToTable(String backupFileDescriptor, String fileName) {

    TableItem tableItem = null;

    tableItem = new TableItem(backupFileTable, SWT.NONE);
    String policyNumber = (fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
        FastlaneFormBackup.POLICY_ALPHA)
        + " " + fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor, FastlaneFormBackup.POLICY_NUMBER))
        .trim();

    tableItem.setText(1, fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
        FastlaneFormBackup.BACKUP_DATE));
    tableItem.setText(2, policyNumber);
    tableItem.setText(3, fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
        FastlaneFormBackup.CLIENT_NAME));
    tableItem.setText(4, fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
        FastlaneFormBackup.CLIENT_NUMBER));
    tableItem.setText(5, fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
        FastlaneFormBackup.ORIGINAL_FILENAME));
    tableItem.setText(6, fileName);
    // tableItem.setText(7, fastlaneFormBackup.getPropertyFromDescriptor(backupFileDescriptor,
    // FastlaneFormBackup.INFO));

  }

  private void saveEFormButtonSelected(SelectionEvent evt) {

    // Check if a selection was made
    if (backupFileTable.getSelection().length == 0) {
      new ErrMessage().showNoBackupFileSelected();
      return;
    }

    // Get the name of the backup file
    String backupFileName = backupFileTable.getSelection()[0].getText(6);

    // get the original EForm file name to use as sample for Save As.. dialog
    String eFormFileName = backupFileTable.getSelection()[0].getText(5);

    // Show Save As.. dialog for user
    FileDialog fileDialog = new FileDialog(this.dialogShell, SWT.SAVE);
    fileDialog.setText("Select EForm save location");
    fileDialog.setFileName(eFormFileName);
    fileDialog.setFilterExtensions(new String[] { "*.pdf" });
    fileDialog.open();

    if (fileDialog.getFilterPath().equalsIgnoreCase("")) {
      return;
    }

    String selectedFileName = fileDialog.getFileName();
    if (!selectedFileName.toLowerCase().endsWith(".pdf")) {
      selectedFileName += ".pdf";
    }

    // Get full path where to save image to
    String fullFileSavepath = fileDialog.getFilterPath() + File.separator + fileDialog.getFileName();

    // Now get the bytes of the actual file
    byte[] eFormFileBytes = fastlaneFormBackup.getEFormFileBytesFromBackupFile(backupFileName);
    if (eFormFileBytes == null) {
      MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Save Form Error",
          "Could not find form with name " + backupFileName + " in Fastlane backup location");
      return;
    }

    // Write the bytes to the user selected File
    try {
      FileOutputStream fos = new FileOutputStream(fullFileSavepath);
      fos.write(eFormFileBytes);
      fos.close();

      MessageDialog.openInformation(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Form Saved",
          "Form saved successfully as:\n\n" + fullFileSavepath);

    } catch (Exception e) {
      e.printStackTrace();

      MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Save Form Error",
          "Could not save form as:\n\n" + fullFileSavepath);
    }
  }

  class MenuItemListener extends SelectionAdapter {
    public void widgetSelected(SelectionEvent event) {
      if (((MenuItem) event.widget).getText().startsWith("Save")) {
        saveEFormButtonSelected(null);
      } else {
        cmdRestoreFormWidgetSelected(null);
      }
    }
  }

  private void imageTableMouseDoubleClick(MouseEvent evt) {
    backupFileTable.getMenu().setVisible(true);
  }

  private void cmdRestoreFormWidgetSelected(SelectionEvent evt) {
    // Check if a selection was made
    if (backupFileTable.getSelection().length == 0) {
      new ErrMessage().showNoBackupFileSelected();
      return;
    }

    // Get the name of the backup file
    String backupFileName = backupFileTable.getSelection()[0].getText(6);

    // get the original EForm file name to use
    String eFormFileName = backupFileTable.getSelection()[0].getText(5);

    // Get full path where to save image to
    String restoreLocation = PdfFileManager.getWorkDirectory() + backupFileTable.getSelection()[0].getText(4);
    String fullFileSavepath = restoreLocation + File.separator + eFormFileName;
    
    // Replace forward slashes to back slashes
    fullFileSavepath = fullFileSavepath.replaceAll("/", "\\\\");

    // Check if the file already exists
    File restoredFile = new File(fullFileSavepath);
    if (restoredFile.exists()) {
      MessageBox messageBox = new MessageBox(ClientWindowManager.getInstance().getShell(), SWT.ICON_WARNING | SWT.YES
          | SWT.NO);
      messageBox.setText("Form Already Exists");
      String message = "A file with name "
          + eFormFileName
          + " already exists in the restore location ("
          + restoreLocation
          + ").\n\nWould you like to overwrite the existing file?\n\nNote: Any changes to the existing file will be lost!";

      messageBox.setMessage(message);

      int selectionId = messageBox.open();
      if (selectionId == SWT.NO) {
        return;
      }

      // Delete the existing file when user selected yes
      if (!restoredFile.delete()) {
        MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
            "Delete Existing Form Error", "Could not delete the existing file at:\n\n" + restoreLocation
                + "\n\nPlease close any applications that might be using this file");
        return;
      }
    }

    // Create the folder
    File restoreDir = new File(restoreLocation);
    if (!restoreDir.exists()) {
      if (!restoreDir.mkdir()) {
        MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Restore Form Error",
            "Could not create restore folder at: " + restoreLocation);
        return;
      }
    }

    // Now get the bytes of the actual file
    byte[] eFormFileBytes = fastlaneFormBackup.getEFormFileBytesFromBackupFile(backupFileName);
    if (eFormFileBytes == null) {
      MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Save Form Error",
          "Could not find form with name " + backupFileName + " in Fastlane backup location");
      return;
    }

    // Write the bytes to the file in the restore folder
    try {
      FileOutputStream fos = new FileOutputStream(fullFileSavepath);
      fos.write(eFormFileBytes);
      fos.close();

      MessageDialog.openInformation(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Form Restored",
          "Form restored successfully as:\n\n" + fullFileSavepath);

    } catch (Exception e) {
      e.printStackTrace();

      MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Restore Form Error",
          "Could not restore form as:\n\n" + fullFileSavepath);
    }
  }
  
  private void last30DaysWidgetSelected(SelectionEvent evt) {
    loadTableDefault();
  }
  
  private void allFormsWidgetSelected(SelectionEvent evt) {
    loadTableAll();
  }

  public class CreatedAWDTransaction {
    String result;
  }

  public class ByterArrayHolder {
    byte[] byteArray;
  }
}
