/*
 * Momentum Risk & Savings IT
 * Project: Myriad
 * 
 * Created on 07 Mar 2012
 *
 */
package za.co.momentum.recurring.nurse.client.ui;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Calendar;
import java.util.Collection;
import java.util.Iterator;
import java.util.TreeMap;

import org.apache.log4j.Logger;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.PlatformUI;

import za.co.momentum.recurring.base.Util;
import za.co.momentum.recurring.nurse.client.model.ErrMessage;
import za.co.momentum.recurring.nurse.client.sao.eform.EFormServiceManager;
import za.co.momentum.recurring.nurse.client.tools.TimedRunException;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import za.co.momentum.risk.fastlane.nurse.dto.EFormTO;

import com.swtdesigner.SWTResourceManager;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ImagesDialog extends org.eclipse.swt.widgets.Dialog {

  private static final Logger LOG = Logger.getLogger(ImagesDialog.class);
  
  private Shell dialogShell;

  private final AppDetailTO appreq;

  private Button cmdView;

  private Button cmdCancel;

  private Composite cmdArea;

  private TableColumn tcImageName;

  private Table imageTable;

  EFormTO[] eforms = new EFormTO[0];

  private TableColumn tMcode;

  private TableColumn tRow;

  private TableColumn tcId;

  private TableColumn tDateCreated;

  private TableColumn tLifeAssured;

  private TableColumn tPolNo;


  public ImagesDialog(Shell parent, int style) {
    super(parent, style);
    appreq = null;
  }

  // public ImagesDialog(Shell parent, int style, final AppDetailTO appreq)
  // throws TimedRunException {
  // super(parent, style);
  // this.appreq = appreq;
  //
  // try {
  // eforms = EFormServiceManager.getInstance().getEFormsForClient(
  // appreq.getClients()[0].getId());
  //
  // } catch (Exception e) {
  // throw new TimedRunException(e);
  // }
  //
  // }

  public ImagesDialog(Shell parent, int style, final AppDetailTO appreq) throws TimedRunException {
    super(parent, style);
    this.appreq = appreq;

    try {
      eforms = EFormServiceManager.getInstance().getAvailableEFormsForClient(appreq.getClients()[0].getId());

    } catch (Exception e) {
      e.printStackTrace();
      if (!(e instanceof ArrayIndexOutOfBoundsException)) {
        throw new TimedRunException(e);
      }
    }

  }
 
  public void open() {
    try {
      Shell parent = getParent();
      dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);

      dialogShell.setLayout(new GridLayout());
      dialogShell.layout();
      dialogShell.pack();
      dialogShell.setSize(850, 385);
      dialogShell.setText("Forms available for this appointment request");
      {
        imageTable = new Table(dialogShell, SWT.FULL_SELECTION | SWT.BORDER);
        GridData imageTableLData = new GridData();
        imageTableLData.horizontalAlignment = GridData.FILL;
        imageTableLData.grabExcessHorizontalSpace = true;
        imageTableLData.grabExcessVerticalSpace = true;
        imageTableLData.verticalAlignment = GridData.FILL;
        imageTable.setLayoutData(imageTableLData);
        imageTable.setLinesVisible(true);
        imageTable.setHeaderVisible(true);
        {
          tRow = new TableColumn(imageTable, SWT.NONE);
          tRow.setWidth(2);
        }
        {
          tcImageName = new TableColumn(imageTable, SWT.NONE);
          tcImageName.setText("Form Name");
          tcImageName.setWidth(108);
        }
        {
          tPolNo = new TableColumn(imageTable, SWT.NONE);
          tPolNo.setText("Policy Number");
          tPolNo.setWidth(120);
        }
        {
          tLifeAssured = new TableColumn(imageTable, SWT.NONE);
          tLifeAssured.setText("Client Name");
          tLifeAssured.setWidth(216);
        }
        {
          tLifeAssured = new TableColumn(imageTable, SWT.NONE);
          tLifeAssured.setText("Client Number");
          tLifeAssured.setWidth(100);
        }
        {
          tMcode = new TableColumn(imageTable, SWT.NONE);
          tMcode.setText("M Code");
          tMcode.setWidth(70);
        }
        {
          tDateCreated = new TableColumn(imageTable, SWT.NONE);
          tDateCreated.setText("Date Created");
          tDateCreated.setWidth(120);
        }
        {
          tcId = new TableColumn(imageTable, SWT.NONE);
          tcId.setText("Form Id");
          tcId.setWidth(70);
        }
      }
      {
        cmdArea = new Composite(dialogShell, SWT.NONE);
        GridLayout cmdAreaLayout = new GridLayout();
        cmdAreaLayout.numColumns = 2;
        cmdAreaLayout.makeColumnsEqualWidth = true;
        cmdArea.setLayout(cmdAreaLayout);
        GridData cmdAreaLData = new GridData();
        cmdAreaLData.widthHint = 830;
        cmdAreaLData.heightHint = 43;
        cmdAreaLData.horizontalAlignment = GridData.CENTER;
        cmdArea.setLayoutData(cmdAreaLData);
        {
          cmdView = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
          GridData cmdViewLData = new GridData();
          cmdViewLData.horizontalAlignment = GridData.END;
          cmdViewLData.heightHint = 31;
          cmdViewLData.grabExcessHorizontalSpace = true;
          cmdViewLData.widthHint = 98;
          cmdView.setLayoutData(cmdViewLData);
          cmdView.setText("Save Form As...");
          cmdView.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
              saveImageButtonSelected(evt);
            }
          });
        }
        {
          cmdCancel = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
          GridData cmdCancelLData = new GridData();
          cmdCancelLData.heightHint = 31;
          cmdCancelLData.widthHint = 98;
          cmdCancel.setLayoutData(cmdCancelLData);
          cmdCancel.setText("Close");
          cmdCancel.addMouseListener(new MouseAdapter() {
            public void mouseDown(MouseEvent evt) {
              cmdCancelMouseDown(evt);
            }
          });
        }
      }
      dialogShell.open();

      loadTable();

      Display display = dialogShell.getDisplay();
      while (!dialogShell.isDisposed()) {
        if (!display.readAndDispatch())
          display.sleep();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

  }

  private void cmdCancelMouseDown(MouseEvent evt) {
    dialogShell.close();
  }

  private void loadTable() {
    if (eforms == null)
      return;
    tRow.setWidth(0);
    imageTable.removeAll();

    if (eforms.length == 0) {
      EFormTO eformTO = new EFormTO();
      eformTO.setClientName("No forms on server. Please submit.");
      eformTO.setClientNo("");
      eformTO.setCreatedDate(0);
      eformTO.setFormName("");
      eformTO.setId(null);
      eformTO.setMCode("");
      eformTO.setPolNo("");

      eforms = new EFormTO[] { eformTO };
    }

    // Sort forms by date for screen
    TreeMap treeForms = new TreeMap();
    for (int i = 0; i < eforms.length; i++) {
      treeForms.put(new Long(eforms[i].getCreatedDate()), eforms[i]);
    }

    Collection formsCol = treeForms.values();
    Iterator it = formsCol.iterator();
    int i = 0;
    while (it.hasNext()) {
      addRow((EFormTO) it.next(), i, imageTable);
      i++;
    }

    // for (int i = 0; i < eforms.length; i++) {
    // EFormTO ef = eforms[i];
    //
    // addRow(ef, i, imageTable);
    // }
  }

  private void addRow(EFormTO ef, int row, Table tb) {
    TableItem t = null;

    if (row < tb.getItemCount()) {
      t = tb.getItem(row);
    } else {
      t = new TableItem(tb, SWT.NONE);
    }
    t.setText(0, String.valueOf(row));
    if (ef.getFormName() != null) {
      t.setText(1, ef.getFormName());
    } else {
      t.setText(1, "");
    }
    t.setText(2, ef.getPolNo());
    t.setText(3, ef.getClientName());
    t.setText(4, ef.getClientNo());
    t.setText(5, ef.getMCode());
    t.setText(6, ef.getCreatedDate() != 0 ? Util.getDateTimeStringFromDate(new java.util.Date(ef.getCreatedDate()))
        : "");
    t.setText(7, ef.getId() != null ? String.valueOf(ef.getId()) : "");

  }

  private void saveImageButtonSelected(SelectionEvent evt) {
    if (imageTable.getSelection().length == 0) {
      new ErrMessage().showNoBackupFileSelected();
      return;
    }
    // Check if a form is in fact available
    if (imageTable.getSelection()[0].getText(3).startsWith("No forms available.")) {
      return;
    }
    final long i = Integer.parseInt(imageTable.getSelection()[0].getText(7));

    final String fileName = imageTable.getSelection()[0].getText(4) + "_" + imageTable.getSelection()[0].getText(1)
        + ".pdf";

    try {
      ByterArrayHolder bah = new ByterArrayHolder();
      
      bah.byteArray = EFormServiceManager.getInstance().getEForm(i);

      FileDialog fd = new FileDialog(this.dialogShell, SWT.SAVE);
      fd.setFileName(fileName);
      fd.open();

      String fn = fd.getFileName();

      if (!fn.endsWith(".pdf")) {
        fn = fn + ".pdf";
      }
      String dir = fd.getFilterPath();

      // If cancel was pressed, then exit
      if (dir.equalsIgnoreCase(""))
        return;

      fn = dir + File.separator + fn;
      if (fn != null & fn.length() > 0) {

        try {
          FileOutputStream fw = new FileOutputStream(fn);
          fw.write(bah.byteArray);
          fw.close();

          MessageDialog.openInformation(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Save Form",
              "Form saved successfully to:\n\n" + fn);

        } catch (Exception e) {
          e.printStackTrace();
        }
      }

    } catch (Exception e) {
      new ErrMessage().showUserDefinedMessage("Transfer failed");

    } finally {
      try {
        PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell()
            .setCursor(SWTResourceManager.getCursor(SWT.CURSOR_ARROW));
      } catch (IllegalStateException e) {
      } // Not a problem.
    }
   
  }

  public class ByterArrayHolder {
    byte[] byteArray;
  }
}
