/*
 * Created on 2005/08/16
 */
package za.co.momentum.recurring.nurse.client.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.recurring.nurse.client.sao.suburb.SuburbServiceManager;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import com.swtdesigner.SWTResourceManager;


public class MainWindow implements WindowIFace {

	protected Shell shell;

	public static void main(String[] args) {

		try {
			// LoginWindow l = new LoginWindow();
			// l.open();

			SuburbServiceManager.getInstance().getSuburbList();
		//	WindowManager.getInstance().createWindow(WindowManager.LOGIN_WINDOW);
		} catch (Exception e) {
			e.printStackTrace();
		}
		SWTResourceManager.dispose();

	}

	public void hide() {
		shell.setVisible(false);
	}

	public void focus() {
		shell.setVisible(true);
		shell.setMinimized(false);
		shell.forceActive();
	}

	public void setLocation(int x, int y) {
		shell.setLocation(x, y);
	}

	public void open() {
		final Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	protected void createContents() {
		shell = new Shell(SWT.SHELL_TRIM);
		
		shell.setLayout(new FillLayout());
		shell.setImage(SWTResourceManager.getImage(MainWindow.class, "/icons/logo-m.gif"));
		shell.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				//WindowManager.getInstance().deleteWindow(WindowManager.MAIN_WINDOW);
			}
		});
		//shell.setImage(SWTResourceManager.getImage(MainWindow.class, "/opfor.ico"));
		shell.setSize(734, 519);
		shell.setText(Application.APPLICATION_NAME);

		final Menu menu = new Menu(shell, SWT.BAR);
		shell.setMenuBar(menu);

		final MenuItem fileMenuItem = new MenuItem(menu, SWT.CASCADE);
		fileMenuItem.setText("File");

		final Menu menu_1 = new Menu(fileMenuItem);
		fileMenuItem.setMenu(menu_1);

		final MenuItem logoutMenuItem = new MenuItem(menu_1, SWT.NONE);
		logoutMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
		//		if (	WindowManager.getInstance().canExit()){
			//	WindowManager.getInstance().deleteAllWindows();
		//		shell.dispose();
		//		WindowManager.getInstance().createWindow(WindowManager.LOGIN_WINDOW);
		//		}
		//		else
		//		{
		//			MessageDialog.openInformation(
		//					shell,
		//					"Exit",
			//				"Please close all other windows before exiting");
		//		}

			}
		});
		logoutMenuItem.setText("Logout");

		final MenuItem exitMenuItem = new MenuItem(menu_1, SWT.NONE);
		exitMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
//				if (	WindowManager.getInstance().canExit()){
//				WindowManager.getInstance().deleteAllWindows();
//				shell.dispose();
//				} else{
//					MessageDialog.openInformation(
//							shell,
//							"Exit",
//							"Please close all other windows before exiting");
//				}
			}
		});
		exitMenuItem.setText("Exit");

		final MenuItem viewMenuItem = new MenuItem(menu, SWT.CASCADE);
		viewMenuItem.setText("View");
		if (ClientSecurityManager.getInstance().isDCRole()
				|| ClientSecurityManager.getInstance().isNurseRole()) {
			viewMenuItem.setEnabled(true);
		} else {
			viewMenuItem.setEnabled(false);
		}

		final Menu menu_2 = new Menu(viewMenuItem);
		viewMenuItem.setMenu(menu_2);

		final MenuItem appointmentRequestListMenuItem = new MenuItem(menu_2,
				SWT.NONE);
		appointmentRequestListMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
//				if (WindowManager.getInstance().windowExits(WindowManager.VIEW_WINDOW)) {
//					WindowManager.getInstance().showWindow(WindowManager.VIEW_WINDOW);
//				} else {
//					WindowManager.getInstance().createWindow(WindowManager.VIEW_WINDOW);
//
//				}
			}
		});
		appointmentRequestListMenuItem.setText("Appointment request list");
		if (ClientSecurityManager.getInstance().isDCRole()) {
			appointmentRequestListMenuItem.setEnabled(true);
		} else {
			appointmentRequestListMenuItem.setEnabled(false);
		}

		final MenuItem diaryMenuItem = new MenuItem(menu_2, SWT.NONE);
		diaryMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
			}
		});
		diaryMenuItem.setText("Diary");
		if (ClientSecurityManager.getInstance().isNurseRole()) {
			diaryMenuItem.setEnabled(true);
		} else {
			diaryMenuItem.setEnabled(false);
		}

		final MenuItem schedulesMenuItem = new MenuItem(menu_2, SWT.NONE);
		schedulesMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
//				if (WindowManager.getInstance().windowExits(
//						WindowManager.SCHEDULES_WINDOW)) {
//					WindowManager.getInstance()
//							.showWindow(WindowManager.SCHEDULES_WINDOW);
//				} else {
//					WindowManager.getInstance().createWindow(
//							WindowManager.SCHEDULES_WINDOW);
//
//				}
			}
		});
		schedulesMenuItem.setEnabled(false);
		if (ClientSecurityManager.getInstance().isNurseRole()) {
			schedulesMenuItem.setText("Schedule");
		} else if (ClientSecurityManager.getInstance().isDCRole()) {
			schedulesMenuItem.setText("Schedules");
			schedulesMenuItem.setEnabled(true);
		}

		final MenuItem searchMenuItem = new MenuItem(menu, SWT.CASCADE);

		searchMenuItem.setText("Search");
		if (ClientSecurityManager.getInstance().isDCRole()) {
			searchMenuItem.setEnabled(true);
		} else {
			searchMenuItem.setEnabled(false);
		}

		final Menu menu_3 = new Menu(searchMenuItem);
		searchMenuItem.setMenu(menu_3);

		final MenuItem appointmentRequestMenuItem = new MenuItem(menu_3, SWT.NONE);
		appointmentRequestMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
			}
		});
		appointmentRequestMenuItem.setText("Appointment request");

		final MenuItem appointmentMenuItem = new MenuItem(menu, SWT.CASCADE);
		appointmentMenuItem.setEnabled(false);
		appointmentMenuItem.setText("Action");

		final Menu actionMenu = new Menu(appointmentMenuItem);
		appointmentMenuItem.setMenu(actionMenu);

		final MenuItem scheduleMenuItem = new MenuItem(actionMenu, SWT.NONE);
		scheduleMenuItem.setText("Schedule");

		final MenuItem rescheduleMenuItem = new MenuItem(actionMenu, SWT.NONE);
		rescheduleMenuItem.setText("Reschedule");

		final MenuItem cancelMenuItem = new MenuItem(actionMenu, SWT.CASCADE);
		cancelMenuItem.setText("Cancel");

		final Menu menu_5 = new Menu(cancelMenuItem);
		cancelMenuItem.setMenu(menu_5);

		final MenuItem nurseMenuItem = new MenuItem(menu_5, SWT.NONE);
		nurseMenuItem.setText("Nurse");

		final MenuItem clientMenuItem = new MenuItem(menu_5, SWT.NONE);
		clientMenuItem.setText("Client");

		final MenuItem diariseMenuItem = new MenuItem(actionMenu, SWT.NONE);
		diariseMenuItem.setText("Diarise");

		final MenuItem administratorMenuItem = new MenuItem(menu, SWT.CASCADE);
		administratorMenuItem.setText("Administrator");
		if (ClientSecurityManager.getInstance().isAdminRole()) {
			administratorMenuItem.setEnabled(true);
		} else {
			administratorMenuItem.setEnabled(false);
		}

		final Menu menu_6 = new Menu(administratorMenuItem);
		administratorMenuItem.setMenu(menu_6);

		final MenuItem createUserMenuItem = new MenuItem(menu_6, SWT.NONE);
		createUserMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				UserServiceManager.getInstance().setTempUser(null);
//				if (WindowManager.getInstance().windowExits(WindowManager.USER_WINDOW)) {
//					WindowManager.getInstance().showWindow(WindowManager.USER_WINDOW);
//				} else {
//					ClientApplicationManager.getInstance().setNewUser(true);
//					WindowManager.getInstance().createWindow(WindowManager.USER_WINDOW);
//
//				}

			}
		});
		createUserMenuItem.setText("Create user");

		final MenuItem updateUserMenuItem = new MenuItem(menu_6, SWT.NONE);
		updateUserMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
//				if (WindowManager.getInstance().windowExits(WindowManager.USER_WINDOW)) {
//					SelectUser su = new SelectUser(shell);
//					su.open();
//					WindowManager.getInstance().showWindow(WindowManager.USER_WINDOW);
//				} else {
//					SelectUser su = new SelectUser(shell);
//					su.open();
//					UserTO user = ClientApplicationManager.getInstance().getTempUser();
//					if (user != null){
//						ClientApplicationManager.getInstance().setNewUser(false);
//						WindowManager.getInstance().createWindow(WindowManager.USER_WINDOW);
//					}
//				}
			}
		});
		updateUserMenuItem.setText("Update user");
		final MenuItem lockScreenMenuItem = new MenuItem(menu_1, SWT.NONE);
		lockScreenMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (lockScreenMenuItem.getText().equalsIgnoreCase("Lock screen")) {
		//			WindowManager.getInstance().hideActiveWindows();
					searchMenuItem.setEnabled(false);
					viewMenuItem.setEnabled(false);
					appointmentMenuItem.setEnabled(false);
					administratorMenuItem.setEnabled(false);
					lockScreenMenuItem.setText("Unlock screen");
				} else {
					LoginWindow l = new LoginWindow();
					l.open();

			//		WindowManager.getInstance().restoreActiveWindows();
					lockScreenMenuItem.setText("Lock screen");
					if (ClientSecurityManager.getInstance().isAdminRole()) {
						administratorMenuItem.setEnabled(true);
					}
					if (ClientSecurityManager.getInstance().isDCRole()) {
						searchMenuItem.setEnabled(true);
						viewMenuItem.setEnabled(true);
					}
					if (ClientSecurityManager.getInstance().isNurseRole()) {
						viewMenuItem.setEnabled(true);
					}
				}
			}
		});
		lockScreenMenuItem.setText("Lock screen");

		final Canvas canvas = new Canvas(shell, SWT.BORDER);

		final Label label = new Label(canvas, SWT.SHADOW_NONE);
		label.setImage(SWTResourceManager.getImage(MainWindow.class, "/icons/Headerlogo_mom.jpg"));
		label.setBounds(358, 253, 345, 210);

		final Label label_1 = new Label(canvas, SWT.NONE);
		label_1.setImage(SWTResourceManager.getImage(MainWindow.class, "/icons/myriadheader~1.jpg"));
		label_1.setBounds(23, 34, 432, 145);
	}

	public void dispose() {
		shell.dispose();
	}

}
