package za.co.momentum.recurring.nurse.client.ui;

import java.awt.Color;
import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.ws.rs.ProcessingException;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import za.co.momentum.recurring.base.Util;
import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.client.TNPlugin.actions.AppointmentDoneAction;
import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.recurring.nurse.client.model.ClientWindowManager;
import za.co.momentum.recurring.nurse.client.model.ErrMessage;
import za.co.momentum.recurring.nurse.client.sao.appreq.AppReqServiceManager;
import za.co.momentum.recurring.nurse.client.tools.PdfFileManager;
import za.co.momentum.recurring.nurse.client.tools.TimedRunException;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.AppReqAppointment;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.Appointment;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.AppointmentSelectedListener;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.DayTimeslotCalendar;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.PersonalAppointment;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.SelectedDateChangedListener;
import za.co.momentum.recurring.nurse.client.ui.tools.ContinuousProgressBar;
import za.co.momentum.recurring.nurse.client.ui.tools.ProgressAction;
import za.co.momentum.recurring.nurse.client.ui.wizards.RescheduleAppointmentWizzard;
import za.co.momentum.recurring.nurse.util.DBHelper;
import za.co.momentum.recurring.nurse.util.TNLogger;
import za.co.momentum.risk.fastlane.exceptions.EntityNotFoundException;
import za.co.momentum.risk.fastlane.nurse.dto.AppClientTO;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import za.co.momentum.risk.fastlane.nurse.dto.RequirementTO;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import za.co.momentum.risk.fastlane.nurse.eforms.FormDTO;
import za.co.momentum.risk.fastlane.nurse.exceptions.AppReqLockedException;
import za.co.momentum.risk.fastlane.nurse.services.appreq.AppReqService;
import za.co.momentum.risk.fastlane.nurse.services.appreq.AppReqServiceRest;
import za.co.momentum.risk.fastlane.nurse.services.eform.EFormService;
import za.co.momentum.risk.fastlane.nurse.services.eform.EFormServiceRest;

import com.cloudgarden.resource.SWTResourceManager;
import com.swtdesigner.ResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class NewNurseCalendarView extends ViewPart {

	public static final String ID_VIEW = "za.co.momentum.recurring.nurse.client.ui.NewNurseCalendarView"; //$NON-NLS-1$

	private static final int DEFAULT_TIMESLOT = 15;

	private ToolItem clientCancelledBtn;

	private ToolItem clientDeclinedBtn;

	private Label label3;

	private Composite clientDetailsComposite;

	private ToolItem toolItem3;

	private ToolItem toolItem5;

	private Text referenceNumber;

	private Label label8;

	private Label label7;

	private Label labelInteractive;

	private Text venue;

	private Text contactPerson;

	private Label label21;

	private Label label20;

	private Text details;

	private Text branch;

	private Label label19;

	private Label label18;

	private Composite composite4;

	private ScrolledComposite scrolledComposite1;

	private Button loadAppointmentsBtn;

	private Button lanEng;

	private Button lanAfr;

	private ToolItem rescheduleAppointmentBtn;

	private ToolItem updateDetailsBtn;

	private ToolItem nurseCancelledBtn;

	private Label label9;

	private ToolItem appointmentDone;

	private ToolItem viewForms;

	private TabItem personal;

	private TabItem appointments;

	private TabFolder tabFolder1;

	private Button deleteAppointmentButton;

	private Button cancelButton;

	private Label minutesLabel_1;

	private Label durationLabel;

	private Text personalAppDescr_1;

	private Label descriptionLabel_1;

	private Text dateSelectedField_1;

	private Label fromDateLabel_1;

	private Button bookAppointmentButton_1;

	private ToolItem toolItem1;

	private ToolItem toolItem21;

	private ToolItem toolItem31;

	private ToolItem toolItem41;

	private ToolItem toolItem51;

	private ToolItem toolItem61;

	private ToolItem toolItem71;

	private Spinner durationSpinner;

	private Group personalAppGroup;

	private Text newComments;

	private ToolItem toolItem4;

	private ToolItem toolItem6;

	private ToolItem toolItem7;

	private Text appTime;

	private Label label16;

	private DayTimeslotCalendar dayTimeslotCalendar1;

	private Composite composite3;

	private SWTCalendar sWTCalendar1;

	private Composite calendarComposite;

	private Composite appointmentComposite;

	private StyledText comments;

	private Label label17;

	private Label label15;

	private Text additionalRequirements;

	private Label label14;

	private Text contactDetails;

	private Label label13;

	private Label label12;

	private Text dc;

	private Label label11;

	private Label label23;

	private Label label118;

	private Text broker;

	private Label label10;

	private Text idNumber;

	private Text interactive;

	private Text clientNumber;

	private Label label6;

	private ToolItem toolItem2;

	private ToolBar toolBar2;

	private Label label5;

	private List forms;

	private Composite formselectionComposite;

	private Text policyNumber;

	private Label label4;

	private Text name;

	private Label label1;

	private List clients;

	private Composite composite2;

	private Composite composite1;

	private Composite mainCom;

	private ToolBar actionToolbar;

	private UserTO user;

	private AppDetailTO[] appReqDetailsTO;

	private AppDetailTO currentApp;

	private AppClientTO currentClient;

	private int tabSelected;

	/**
   * 
   */
	public NewNurseCalendarView() {
		super();
		//
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets
	 * .Composite)
	 */
	public void createPartControl(Composite parent) {
		{
			parent.setSize(64, 64);
		}
		{
			user = ClientSecurityManager.getInstance().getUser();
			{
				parent.setSize(793, 1057);
				mainCom = new Composite(parent, SWT.NONE);
				GridLayout gridLayoutMain = new GridLayout();
				mainCom.setLayout(gridLayoutMain);
				{
					GridData toolBar1LData = new GridData();
					toolBar1LData.grabExcessHorizontalSpace = true;
					toolBar1LData.horizontalAlignment = GridData.FILL;
					toolBar1LData.horizontalSpan = 0;
					toolBar1LData.minimumHeight = 26;
					toolBar1LData.verticalAlignment = GridData.FILL;
					toolBar1LData.verticalSpan = 2;
					actionToolbar = new ToolBar(mainCom, SWT.FLAT);
					actionToolbar.setLayoutData(toolBar1LData);
					actionToolbar.setBackground(SWTResourceManager.getColor(
							255, 255, 210));
					actionToolbar.setForeground(SWTResourceManager.getColor(
							255, 255, 255));
					actionToolbar.setFont(SWTResourceManager.getFont("Arial",
							8, 0, false, false));
					actionToolbar.setSize(783, 25);
					actionToolbar.setVisible(false);
					{
						clientCancelledBtn = new ToolItem(actionToolbar,
								SWT.NONE);
						clientCancelledBtn.setText("Client cancelled");
						clientCancelledBtn.setWidth(0);
						clientCancelledBtn
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										clientCancelledBtnWidgetSelected(evt);
									}
								});
					}
					{
						toolItem1 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem1.setText("");
					}
					{
						clientDeclinedBtn = new ToolItem(actionToolbar,
								SWT.NONE);
						clientDeclinedBtn.setText("Client declined");
						clientDeclinedBtn.setWidth(0);
						clientDeclinedBtn
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										clientDeclinedBtnWidgetSelected(evt);
									}
								});
					}
					{
						toolItem21 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem21.setText("");
					}
					{
						rescheduleAppointmentBtn = new ToolItem(actionToolbar,
								SWT.NONE);
						rescheduleAppointmentBtn.setText("Reschedule");
						rescheduleAppointmentBtn
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										rescheduleAppointmentBtnWidgetSelected(evt);
									}
								});
					}
					{
						toolItem31 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem31.setText("");
					}
					{
						nurseCancelledBtn = new ToolItem(actionToolbar,
								SWT.NONE);
						nurseCancelledBtn.setText("Nurse cancelled");
						nurseCancelledBtn
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										nurseCancelledBtnWidgetSelected(evt);
									}
								});
					}
					{
						toolItem41 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem41.setText("");
					}
					{
						updateDetailsBtn = new ToolItem(actionToolbar, SWT.NONE);
						updateDetailsBtn.setText("Update details");
						updateDetailsBtn
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										updateDetailsBtnWidgetSelected(evt);
									}
								});
					}
					{
						toolItem51 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem51.setText("");
					}
					{
						viewForms = new ToolItem(actionToolbar, SWT.NONE);
						viewForms.setText("View forms on server");
						viewForms
								.setToolTipText("Click here to view the forms currently on the server for this policy");
						viewForms.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								viewFormsWidgetSelected(evt);
							}
						});
					}
					{
						toolItem61 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem61.setText("");
					}
					{
						appointmentDone = new ToolItem(actionToolbar, SWT.NONE);
						appointmentDone.setText("Appointment done");
						appointmentDone.setToolTipText("Appointment done");
						appointmentDone
								.addSelectionListener(new SelectionAdapter() {
									public void widgetSelected(
											SelectionEvent evt) {
										appointmentDoneWidgetSelected(evt);
									}
								});
					}
					{
						toolItem71 = new ToolItem(actionToolbar, SWT.SEPARATOR);
						toolItem71.setText("");
					}
				}
				{
					GridData composite1LData = new GridData();
					composite1LData.horizontalAlignment = GridData.FILL;
					composite1LData.verticalAlignment = GridData.BEGINNING;
					composite1LData.grabExcessHorizontalSpace = true;
					composite1LData.grabExcessVerticalSpace = true;
					composite1 = new Composite(mainCom, SWT.NONE);
					GridLayout composite1Layout = new GridLayout();
					composite1Layout.numColumns = 2;
					composite1.setLayout(composite1Layout);
					composite1.setLayoutData(composite1LData);
					{
						GridData calendarCompositeLData = new GridData();
						calendarCompositeLData.horizontalAlignment = GridData.FILL;
						calendarCompositeLData.verticalAlignment = GridData.FILL;
						calendarCompositeLData.grabExcessVerticalSpace = true;
						calendarComposite = new Composite(composite1, SWT.NONE);
						GridLayout calendarCompositeLayout = new GridLayout();
						calendarCompositeLayout.numColumns = 2;
						calendarComposite.setLayout(calendarCompositeLayout);
						calendarComposite.setLayoutData(calendarCompositeLData);
						{
							sWTCalendar1 = new SWTCalendar(calendarComposite,
									SWT.NONE);
							GridData sWTCalendar1LData = new GridData();
							sWTCalendar1LData.widthHint = 226;
							sWTCalendar1LData.heightHint = 155;
							sWTCalendar1LData.horizontalAlignment = GridData.CENTER;
							sWTCalendar1LData.horizontalSpan = 2;
							sWTCalendar1.setLayoutData(sWTCalendar1LData);
							sWTCalendar1
									.addSWTCalendarListener(new SWTCalendarListener() {
										public void dateChanged(
												SWTCalendarEvent evt) {
											sWTCalendar1DateChanged(evt);
										}
									});
						}
						{
							loadAppointmentsBtn = new Button(calendarComposite,
									SWT.PUSH | SWT.CENTER);
							loadAppointmentsBtn
									.setText("Load appointments for date");
							String note = "Clicking this button will load all the appointment\ndetails for the above date to the "
									+ "computer's local database.\n\n"
									+ "This gives you the ability to view the appointments as \nwell as prepopulate the requirement forms "
									+ "without being\nconnected to the network.\n\n"
									+ "Once connected you can make the appointment done.";

							GridData loadAppointmentsBtnLData = new GridData();
							loadAppointmentsBtnLData.horizontalAlignment = GridData.CENTER;
							loadAppointmentsBtnLData.widthHint = 169;
							loadAppointmentsBtnLData.heightHint = 24;
							loadAppointmentsBtnLData.verticalAlignment = GridData.END;
							loadAppointmentsBtnLData.horizontalSpan = 2;
							loadAppointmentsBtn
									.setLayoutData(loadAppointmentsBtnLData);
							loadAppointmentsBtn.setToolTipText(note);
							loadAppointmentsBtn.setFont(SWTResourceManager
									.getFont("Tahoma", 8, 1, false, false));
							loadAppointmentsBtn
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent evt) {
											loadAppointmentsBtnWidgetSelected(evt);
										}
									});
						}
						{
							label23 = new Label(calendarComposite, SWT.NONE);
							GridData label23LData = new GridData();
							label23LData.widthHint = 102;
							label23LData.heightHint = 3;
							label23.setLayoutData(label23LData);
							label23.setText("");
						}
						{
							composite3 = new Composite(calendarComposite,
									SWT.NONE);
							FillLayout composite3Layout = new FillLayout(
									org.eclipse.swt.SWT.HORIZONTAL);
							GridData composite3LData = new GridData();
							composite3LData.verticalAlignment = GridData.BEGINNING;
							composite3LData.grabExcessVerticalSpace = true;
							composite3LData.grabExcessHorizontalSpace = true;
							composite3LData.widthHint = 283;
							composite3LData.horizontalSpan = 2;
							composite3LData.heightHint = 500;
							composite3.setLayoutData(composite3LData);
							composite3.setLayout(composite3Layout);
							composite3.setBackground(SWTResourceManager
									.getColor(212, 208, 200));
							{
								dayTimeslotCalendar1 = new DayTimeslotCalendar(
										composite3, SWT.NONE);
								FillLayout dayTimeslotCalendar1Layout = new FillLayout(
										org.eclipse.swt.SWT.HORIZONTAL);

								dayTimeslotCalendar1
										.setLayout(dayTimeslotCalendar1Layout);
								dayTimeslotCalendar1.setHeader("Calendar for "
										+ Util.getStringFromDate(sWTCalendar1
												.getCalendar().getTime()));
								dayTimeslotCalendar1.setTimeslotHeight(60);
								dayTimeslotCalendar1.setStartHour(5);
								((org.eclipse.swt.layout.FillLayout) dayTimeslotCalendar1
										.getLayout()).type = SWT.VERTICAL;
								dayTimeslotCalendar1
										.setHeaderBackground(new Color(255,
												255, 183));
								// dayTimeslotCalendar.setHeaderFont(SWTResourceManager.getFont("",
								// 18,
								// SWT.BOLD));
								dayTimeslotCalendar1.setLabelLength(50);
								dayTimeslotCalendar1
										.setTimeslot1BackGround(new Color(255,
												255, 255));
								dayTimeslotCalendar1
										.setTimeslot2BackGround(new Color(239,
												239, 239));
								dayTimeslotCalendar1
										.setLabel2BackGround(new Color(240,
												240, 240));
								dayTimeslotCalendar1
										.setLabel1BackGround(new Color(255,
												255, 255));
								dayTimeslotCalendar1
										.setAppointmentColor(new Color(194,
												229, 255));
								dayTimeslotCalendar1
										.setTimeslotLengthInMinutes(15);
								dayTimeslotCalendar1.setEndHour(20);
								dayTimeslotCalendar1
										.addDateChangedListener(new SelectedDateChangedListener() {
											public void changeEvent() {
												calendarClicked();
											}
										});
								dayTimeslotCalendar1
										.addAppointmentSelectListener(new AppointmentSelectedListener() {
											public void appointmentSelectedEvent(
													MouseEvent e) {
												appointmentSelected();
											}
										});// addAppointmentSelectListener
							}
						}
					}
					{
						composite2 = new Composite(composite1, SWT.NONE);
						FillLayout composite2Layout = new FillLayout(
								org.eclipse.swt.SWT.HORIZONTAL);
						composite2.setLayout(composite2Layout);
						GridData composite2LData = new GridData();
						composite2LData.horizontalAlignment = GridData.FILL;
						composite2LData.verticalAlignment = GridData.FILL;
						composite2LData.grabExcessVerticalSpace = true;
						composite2LData.grabExcessHorizontalSpace = true;
						composite2LData.minimumWidth = 200;
						composite2LData.minimumHeight = 300;
						composite2.setLayoutData(composite2LData);
						composite2.setBounds(-2, -345, 403, 682);
						composite2.setVisible(false);
						{
							tabFolder1 = new TabFolder(composite2, SWT.NONE);
							tabFolder1
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent evt) {
											tabFolder1WidgetSelected(evt);
										}
									});
							{
								appointments = new TabItem(tabFolder1, SWT.NONE);
								{
									appointmentComposite = new Composite(
											tabFolder1, SWT.NONE);
									appointments
											.setControl(appointmentComposite);
									GridLayout appointmentCompositeLayout = new GridLayout();
									appointmentCompositeLayout.numColumns = 2;
									appointmentComposite
											.setLayout(appointmentCompositeLayout);
									{
										scrolledComposite1 = new ScrolledComposite(
												appointmentComposite,
												SWT.H_SCROLL | SWT.V_SCROLL
														| SWT.BORDER);
										FillLayout scrolledComposite1Layout = new FillLayout(
												org.eclipse.swt.SWT.HORIZONTAL);
										GridData scrolledComposite1LData = new GridData();
										scrolledComposite1LData.grabExcessHorizontalSpace = true;
										scrolledComposite1LData.grabExcessVerticalSpace = true;
										scrolledComposite1LData.horizontalAlignment = GridData.FILL;
										scrolledComposite1LData.verticalAlignment = GridData.FILL;
										scrolledComposite1LData.horizontalSpan = 2;
										scrolledComposite1
												.setLayoutData(scrolledComposite1LData);
										scrolledComposite1
												.setLayout(scrolledComposite1Layout);
										scrolledComposite1
												.setExpandHorizontal(true);
										scrolledComposite1
												.setExpandVertical(true);
										{
											composite4 = new Composite(
													scrolledComposite1,
													SWT.NONE);
											GridLayout composite4Layout = new GridLayout();
											composite4Layout.numColumns = 2;
											composite4
													.setLayout(composite4Layout);
											scrolledComposite1
													.setContent(composite4);
											composite4.setBounds(-257, -336,
													60, 30);
										}
									}
									{
										label9 = new Label(composite4, SWT.NONE);
										GridData label9LData = new GridData();
										label9LData.horizontalSpan = 2;
										label9.setLayoutData(label9LData);
										label9.setText("Appointment Details");
										label9.setFont(SWTResourceManager
												.getFont("Tahoma", 10, 1,
														false, false));
									}
									{
										label6 = new Label(composite4, SWT.WRAP);
										GridData label6LData = new GridData();
										label6LData.verticalAlignment = GridData.BEGINNING;
										label6LData.widthHint = 116;
										label6LData.heightHint = 18;
										label6.setLayoutData(label6LData);
										label6.setText("Location details");
									}
									{
										GridData venueLData = new GridData();
										venueLData.grabExcessHorizontalSpace = true;
										venueLData.heightHint = 76;
										venueLData.horizontalAlignment = GridData.FILL;
										venue = new Text(composite4, SWT.MULTI
												| SWT.READ_ONLY | SWT.WRAP
												| SWT.V_SCROLL | SWT.BORDER);
										venue.setLayoutData(venueLData);
										venue.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										venue.setEditable(false);
									}
									{
										label16 = new Label(composite4,
												SWT.NONE);
										label16.setText("Time booked");
										GridData label16LData = new GridData();
										label16.setLayoutData(label16LData);
									}
									{
										appTime = new Text(composite4,
												SWT.READ_ONLY | SWT.BORDER);
										appTime.setEditable(false);
										GridData text3LData1 = new GridData();
										text3LData1.horizontalAlignment = GridData.FILL;
										text3LData1.grabExcessHorizontalSpace = true;
										text3LData1.heightHint = 14;
										appTime.setLayoutData(text3LData1);
										appTime.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
									}
									{
										label21 = new Label(composite4,
												SWT.WRAP);
										GridData label21LData = new GridData();
										label21LData.verticalAlignment = GridData.BEGINNING;
										label21LData.widthHint = 116;
										label21LData.heightHint = 54;
										label21.setLayoutData(label21LData);
										label21.setText("Contact person details");
									}
									{
										contactPerson = new Text(composite4,
												SWT.MULTI | SWT.READ_ONLY
														| SWT.WRAP
														| SWT.V_SCROLL
														| SWT.BORDER);
										contactPerson.setEditable(false);
										GridData text2LData2 = new GridData();
										text2LData2.horizontalAlignment = GridData.FILL;
										text2LData2.grabExcessHorizontalSpace = true;
										text2LData2.heightHint = 52;
										contactPerson
												.setLayoutData(text2LData2);
										contactPerson
												.setBackground(SWTResourceManager
														.getColor(255, 255, 210));
									}
									{
										label10 = new Label(composite4,
												SWT.NONE);
										GridData label10LData = new GridData();
										label10.setLayoutData(label10LData);
										label10.setText("Broker");
									}
									{
										broker = new Text(composite4,
												SWT.READ_ONLY | SWT.BORDER);
										GridData text2LData = new GridData();
										text2LData.horizontalAlignment = GridData.FILL;
										text2LData.grabExcessHorizontalSpace = true;
										text2LData.heightHint = 14;
										broker.setLayoutData(text2LData);
										broker.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										broker.setEditable(false);
									}
									{
										label19 = new Label(composite4,
												SWT.NONE);
										label19.setText("Branch");
									}
									{
										branch = new Text(composite4,
												SWT.READ_ONLY | SWT.BORDER);
										GridData text2LData = new GridData();
										text2LData.horizontalAlignment = GridData.FILL;
										text2LData.grabExcessHorizontalSpace = true;
										text2LData.heightHint = 14;
										branch.setLayoutData(text2LData);
										branch.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										branch.setEditable(false);
									}
									{
										label11 = new Label(composite4,
												SWT.NONE);
										GridData label11LData = new GridData();
										label11.setLayoutData(label11LData);
										label11.setText("Diary coordinator");
									}
									{
										dc = new Text(composite4, SWT.READ_ONLY
												| SWT.BORDER);
										GridData text3LData = new GridData();
										text3LData.horizontalAlignment = GridData.FILL;
										text3LData.grabExcessHorizontalSpace = true;
										text3LData.heightHint = 14;
										dc.setLayoutData(text3LData);
										dc.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										dc.setEditable(false);
									}
									{
										label17 = new Label(composite4,
												SWT.WRAP);
										label17.setText("Add comments (click 'Update details' to save)");
										GridData label17LData = new GridData();
										label17LData.verticalAlignment = GridData.BEGINNING;
										label17LData.widthHint = 106;
										label17LData.heightHint = 49;
										label17.setLayoutData(label17LData);
									}
									{
										newComments = new Text(composite4,
												SWT.MULTI | SWT.WRAP
														| SWT.V_SCROLL
														| SWT.BORDER);
										GridData text1LData4 = new GridData();
										text1LData4.horizontalAlignment = GridData.FILL;
										text1LData4.grabExcessHorizontalSpace = true;
										text1LData4.heightHint = 43;
										newComments.setLayoutData(text1LData4);
									}
									{
										label15 = new Label(composite4,
												SWT.NONE);
										GridData label15LData = new GridData();
										label15LData.verticalAlignment = GridData.BEGINNING;
										label15.setLayoutData(label15LData);
										label15.setText("Comments");
									}
									{
										comments = new StyledText(composite4,
												SWT.MULTI | SWT.READ_ONLY
														| SWT.WRAP
														| SWT.V_SCROLL
														| SWT.BORDER);
										comments.setEditable(false);
										GridData text2LData2 = new GridData();
										text2LData2.horizontalAlignment = GridData.FILL;
										text2LData2.grabExcessHorizontalSpace = true;
										text2LData2.heightHint = 87;
										comments.setLayoutData(text2LData2);
										comments.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										comments.setIndent(2);
									}
									{
										label1 = new Label(composite4, SWT.NONE);
										label1.setText("Client(s) for this appointment");
										GridData label1LData = new GridData();
										label1LData.horizontalSpan = 2;
										label1.setLayoutData(label1LData);
										label1.setFont(SWTResourceManager
												.getFont("Tahoma", 10, 1,
														false, false));
									}
									{
										label18 = new Label(composite4,
												SWT.NONE);
										label18.setText("Name [client number]");
										GridData label18Data = new GridData();
										label18.setLayoutData(label18Data);
									}
									{
										GridData clientsLData = new GridData();
										clientsLData.verticalAlignment = GridData.BEGINNING;
										clientsLData.minimumHeight = 40;
										clientsLData.verticalSpan = 5;
										clientsLData.heightHint = 30;
										clientsLData.grabExcessHorizontalSpace = true;
										clientsLData.horizontalAlignment = GridData.FILL;
										clients = new List(composite4,
												SWT.SINGLE | SWT.V_SCROLL
														| SWT.BORDER);
										clients.setLayoutData(clientsLData);
										clients.setBackground(SWTResourceManager
												.getColor(255, 255, 210));
										clients.addSelectionListener(new SelectionAdapter() {
											public void widgetSelected(
													SelectionEvent evt) {
												clientsWidgetSelected(evt);
											}
										});
										clients.add("Client 1");
									}
									{
										clientDetailsComposite = new Composite(
												composite4, SWT.NONE);
										GridLayout clientDetailsCompositeLayout = new GridLayout();
										clientDetailsCompositeLayout.numColumns = 3;
										GridData clientDetailsCompositeLData = new GridData();
										clientDetailsCompositeLData.horizontalAlignment = GridData.FILL;
										clientDetailsCompositeLData.verticalAlignment = GridData.FILL;
										clientDetailsCompositeLData.grabExcessHorizontalSpace = true;
										clientDetailsCompositeLData.horizontalSpan = 2;
										clientDetailsComposite
												.setLayoutData(clientDetailsCompositeLData);
										clientDetailsComposite
												.setLayout(clientDetailsCompositeLayout);
										{
											label7 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											label7.setText("Client form ref no");
										}
										{
											referenceNumber = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											GridData referenceNumberLData = new GridData();
											referenceNumberLData.grabExcessHorizontalSpace = true;
											referenceNumberLData.heightHint = 14;
											referenceNumberLData.horizontalSpan = 2;
											referenceNumberLData.horizontalAlignment = GridData.FILL;
											referenceNumber
													.setLayoutData(referenceNumberLData);
											referenceNumber
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											referenceNumber.setEditable(false);
										}
										{
											label3 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label3LData = new GridData();
											label3LData.horizontalAlignment = GridData.FILL;
											label3.setLayoutData(label3LData);
											label3.setText("Name");
										}
										{
											GridData nameLData = new GridData();
											nameLData.grabExcessHorizontalSpace = true;
											nameLData.horizontalAlignment = GridData.FILL;
											nameLData.minimumHeight = 2;
											nameLData.horizontalSpan = 2;
											name = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											name.setLayoutData(nameLData);
											name.setBackground(SWTResourceManager
													.getColor(255, 255, 210));
											name.setEditable(false);
										}
										{
											label4 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label4LData = new GridData();
											label4LData.horizontalAlignment = GridData.FILL;
											label4.setLayoutData(label4LData);
											label4.setText("Policy number");
										}
										{
											GridData surnameLData = new GridData();
											surnameLData.grabExcessHorizontalSpace = true;
											surnameLData.heightHint = 13;
											surnameLData.horizontalSpan = 2;
											surnameLData.horizontalAlignment = GridData.FILL;
											policyNumber = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											policyNumber
													.setLayoutData(surnameLData);
											policyNumber
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											policyNumber.setEditable(false);
										}
										{
											label118 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label118LData = new GridData();
											label118LData.widthHint = 107;
											label118LData.heightHint = 17;
											label118.setLayoutData(label118LData);
											label118.setText("Client number");
										}
										{
											clientNumber = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											GridData text111LData = new GridData();
											text111LData.grabExcessHorizontalSpace = true;
											text111LData.heightHint = 13;
											text111LData.horizontalSpan = 2;
											text111LData.horizontalAlignment = GridData.FILL;
											clientNumber
													.setLayoutData(text111LData);
											clientNumber
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											clientNumber.setEditable(false);
										}
										{
											label8 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label8LData = new GridData();
											label8LData.heightHint = 15;
											label8LData.horizontalAlignment = GridData.FILL;
											label8.setLayoutData(label8LData);
											label8.setText("ID/Passport number");
										}
										{
											idNumber = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											GridData text1LData = new GridData();
											text1LData.grabExcessHorizontalSpace = true;
											text1LData.heightHint = 13;
											text1LData.horizontalSpan = 2;
											text1LData.horizontalAlignment = GridData.FILL;
											idNumber.setLayoutData(text1LData);
											idNumber.setBackground(SWTResourceManager
													.getColor(255, 255, 210));
											idNumber.setEditable(false);
										}
										{
											label12 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label12LData = new GridData();
											label12LData.heightHint = 16;
											label12LData.horizontalAlignment = GridData.FILL;
											label12.setLayoutData(label12LData);
											label12.setText("Language");
										}
										{
											lanAfr = new Button(
													clientDetailsComposite,
													SWT.RADIO | SWT.LEFT);
											lanAfr.setText("Afrikaans");
										}
										{
											lanEng = new Button(
													clientDetailsComposite,
													SWT.RADIO | SWT.LEFT);
											lanEng.setText("English");
										}
										{
											label13 = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData label13LData = new GridData();
											label13LData.heightHint = 15;
											label13LData.verticalAlignment = GridData.BEGINNING;
											label13LData.horizontalAlignment = GridData.FILL;
											label13.setLayoutData(label13LData);
											label13.setText("Contact details");
										}
										{
											contactDetails = new Text(
													clientDetailsComposite,
													SWT.MULTI | SWT.READ_ONLY
															| SWT.WRAP
															| SWT.V_SCROLL
															| SWT.BORDER);
											GridData text2LData1 = new GridData();
											text2LData1.horizontalAlignment = GridData.FILL;
											text2LData1.grabExcessHorizontalSpace = true;
											text2LData1.heightHint = 40;
											text2LData1.horizontalSpan = 2;
											contactDetails
													.setLayoutData(text2LData1);
											contactDetails
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											contactDetails.setEditable(false);
										}
										{
											label14 = new Label(
													clientDetailsComposite,
													SWT.WRAP);
											GridData label14LData = new GridData();
											label14LData.widthHint = 112;
											label14LData.heightHint = 34;
											label14LData.verticalAlignment = GridData.BEGINNING;
											label14.setLayoutData(label14LData);
											label14.setText("Additional requirements");
										}
										{
											additionalRequirements = new Text(
													clientDetailsComposite,
													SWT.MULTI | SWT.WRAP
															| SWT.V_SCROLL
															| SWT.BORDER);
											GridData text1LData3 = new GridData();
											text1LData3.horizontalAlignment = GridData.FILL;
											text1LData3.grabExcessHorizontalSpace = true;
											text1LData3.heightHint = 40;
											text1LData3.horizontalSpan = 2;
											additionalRequirements
													.setLayoutData(text1LData3);
											additionalRequirements
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											additionalRequirements
													.setEditable(false);
										}
										{
											labelInteractive = new Label(
													clientDetailsComposite,
													SWT.NONE);
											GridData labelInteractiveLData = new GridData();
											labelInteractiveLData.heightHint = 15;
											labelInteractiveLData.horizontalAlignment = GridData.FILL;
											labelInteractive
													.setLayoutData(labelInteractiveLData);
											labelInteractive
													.setText("Interactive ?");
										}
										{
											interactive = new Text(
													clientDetailsComposite,
													SWT.READ_ONLY | SWT.BORDER);
											GridData text1LData = new GridData();
											text1LData.grabExcessHorizontalSpace = true;
											text1LData.heightHint = 13;
											text1LData.horizontalSpan = 2;
											text1LData.horizontalAlignment = GridData.FILL;
											interactive
													.setLayoutData(text1LData);
											interactive
													.setBackground(SWTResourceManager
															.getColor(255, 255,
																	210));
											interactive.setEditable(false);
										}
									}
									{
										formselectionComposite = new Composite(
												composite4, SWT.NONE);
										GridLayout formselectionCompositeLayout = new GridLayout();
										formselectionCompositeLayout.makeColumnsEqualWidth = true;
										GridData formselectionCompositeLData = new GridData();
										formselectionCompositeLData.grabExcessHorizontalSpace = true;
										formselectionCompositeLData.horizontalAlignment = GridData.FILL;
										formselectionCompositeLData.horizontalSpan = 2;
										formselectionComposite
												.setLayoutData(formselectionCompositeLData);
										formselectionComposite
												.setLayout(formselectionCompositeLayout);
										{
											label5 = new Label(
													formselectionComposite,
													SWT.NONE);
											label5.setText("Forms to be completed for this client");
											GridData label5LData = new GridData();
											label5LData.heightHint = 15;
											label5LData.horizontalAlignment = GridData.FILL;
											label5.setLayoutData(label5LData);
											label5.setFont(SWTResourceManager
													.getFont("Tahoma", 8, 1,
															false, false));
										}
										{
											GridData formsLData = new GridData();
											formsLData.grabExcessHorizontalSpace = true;
											formsLData.horizontalAlignment = GridData.FILL;
											formsLData.heightHint = 100;
											forms = new List(
													formselectionComposite,
													SWT.H_SCROLL | SWT.V_SCROLL
															| SWT.BORDER);
											forms.setLayoutData(formsLData);
											forms.setBackground(SWTResourceManager
													.getColor(255, 255, 210));
											forms.addMouseListener(new MouseAdapter() {
												public void mouseDoubleClick(
														MouseEvent evt) {
													formsMouseDoubleClick(evt);
												}
											});
										}
										{
											GridData toolBar2LData = new GridData();
											toolBar2LData.grabExcessHorizontalSpace = true;
											toolBar2LData.horizontalAlignment = GridData.FILL;
											toolBar2LData.horizontalIndent = 1;
											toolBar2LData.minimumHeight = 26;
											toolBar2LData.verticalAlignment = GridData.FILL;
											toolBar2LData.verticalSpan = 2;
											toolBar2 = new ToolBar(
													formselectionComposite,
													SWT.FLAT);
											toolBar2.setLayoutData(toolBar2LData);
											toolBar2.setBackground(SWTResourceManager
													.getColor(147, 201, 255));
											{
												toolItem2 = new ToolItem(
														toolBar2, SWT.NONE);
												toolItem2
														.setText("Open selected form ");
												toolItem2
														.setToolTipText("Open selected form");
												toolItem2
														.addSelectionListener(new SelectionAdapter() {
															public void widgetSelected(
																	SelectionEvent evt) {
																toolItem2WidgetSelected(evt);
															}
														});
											}
											{
												toolItem4 = new ToolItem(
														toolBar2, SWT.SEPARATOR);
												toolItem4.setText("toolItem4");
											}
											{
												toolItem3 = new ToolItem(
														toolBar2, SWT.NONE);
												toolItem3
														.setText("Add additional forms ");
												toolItem3
														.setToolTipText("Add additional forms");
												toolItem3
														.addSelectionListener(new SelectionAdapter() {
															public void widgetSelected(
																	SelectionEvent evt) {
																addAdditionalForm(evt);
															}
														});
											}
											{
												toolItem6 = new ToolItem(
														toolBar2, SWT.SEPARATOR);
												toolItem6.setText("toolItem6");
											}
											{
												toolItem5 = new ToolItem(
														toolBar2, SWT.NONE);
												toolItem5
														.setText("View forms in client's work folder ");
												toolItem5
														.setToolTipText("Open this client's work folder to view all opened forms");
												toolItem5
														.addSelectionListener(new SelectionAdapter() {
															public void widgetSelected(
																	SelectionEvent evt) {
																viewFormsInWorkFolder(evt);
															}
														});
											}
											{
												toolItem7 = new ToolItem(
														toolBar2, SWT.SEPARATOR);
												toolItem7.setText("toolItem7");
											}
											// {
											// toolItem8 = new
											// ToolItem(toolBar2, SWT.NONE);
											// toolItem8.setText("Delete forms in work folder ");
											// toolItem8.setToolTipText("Delete all forms in the work folder for this client");
											// toolItem8.addSelectionListener(new
											// SelectionAdapter() {
											// public void
											// widgetSelected(SelectionEvent
											// evt) {
											// viewFormsInWorkFolder(evt);
											// }
											// });
											// }
										}
									}
								}
							}
							{
								personal = new TabItem(tabFolder1, SWT.NONE);
								{
									personalAppGroup = new Group(tabFolder1,
											SWT.NONE);
									personal.setControl(personalAppGroup);
									personalAppGroup
											.setText("Personal/Other Appointment");
									personalAppGroup.setFont(SWTResourceManager
											.getFont("Tahoma", 10, 1, false,
													false));
									{
										durationSpinner = new Spinner(
												personalAppGroup, SWT.BORDER);
										durationSpinner.setSelection(30);
										durationSpinner.setMaximum(120);
										durationSpinner.setMinimum(5);
										durationSpinner.setBounds(111, 106, 55,
												20);
										durationSpinner
												.addModifyListener(new ModifyListener() {
													public void modifyText(
															ModifyEvent evt) {
														dayTimeslotCalendar1
																.setDefaultNewAppointmentTimeInMinutes(durationSpinner
																		.getSelection());
														updateTempAppointment();
													}
												});
									}
									{
										bookAppointmentButton_1 = new Button(
												personalAppGroup, SWT.NONE);
										bookAppointmentButton_1
												.setText("Book appointment");
										bookAppointmentButton_1.setBounds(27,
												36, 122, 21);
										bookAppointmentButton_1
												.addSelectionListener(new SelectionAdapter() {
													public void widgetSelected(
															SelectionEvent evt) {
														Calendar start = dayTimeslotCalendar1
																.getSelectedAppointment()
																.getStartTime();
														Calendar end = Calendar
																.getInstance();
														end.setTimeInMillis(start
																.getTimeInMillis());
														end.add(Calendar.MINUTE,
																durationSpinner
																		.getSelection());
														if (bookAppointmentButton_1
																.getText()
																.equalsIgnoreCase(
																		"Update appointment")) {
															PersonalAppointment app = (PersonalAppointment) dayTimeslotCalendar1
																	.getSelectedAppointment();
															AppDetailTO to = app
																	.getPersonalDairyTO();
															if (new Long(to
																	.getId()) != null) {
																MessageBox message = new MessageBox(
																		PlatformUI
																				.getWorkbench()
																				.getActiveWorkbenchWindow()
																				.getShell(),
																		SWT.ICON_QUESTION
																				| SWT.YES
																				| SWT.NO);
																message.setMessage("Are you sure you want to update this personal appoiontment?");
																message.setText("Message");
																int choice = message
																		.open();
																if (choice == SWT.YES) {
																	to.setEndTimeStamp(end
																			.getTimeInMillis());
																	to.setStartTimeStamp(start
																			.getTimeInMillis());
																	AppReqServiceManager
																			.getInstance()
																			.updatePersonalAppointment(
																					ClientSecurityManager
																							.getInstance()
																							.getUser(),
																					to);
																	updateCalendar();
																}
															}
														} else {
															AppDetailTO personalApp = new AppDetailTO();
															personalApp
																	.setEndTimeStamp(end
																			.getTimeInMillis());
															personalApp
																	.setStartTimeStamp(start
																			.getTimeInMillis());
															AppReqServiceManager
																	.getInstance()
																	.bookPersonalAppointment(
																			ClientSecurityManager
																					.getInstance()
																					.getUser(),
																			personalApp);
															updateCalendar();
														}
													}
												});
									}
									{
										fromDateLabel_1 = new Label(
												personalAppGroup, SWT.NONE);
										fromDateLabel_1
												.setText("Date selected:");
										fromDateLabel_1.setBounds(32, 81, 70,
												15);
									}
									{
										dateSelectedField_1 = new Text(
												personalAppGroup, SWT.BORDER);
										dateSelectedField_1
												.setFont(SWTResourceManager
														.getFont("", 10,
																SWT.BOLD));
										dateSelectedField_1.setEditable(false);
										dateSelectedField_1.setBounds(111, 77,
												223, 23);
									}
									{
										descriptionLabel_1 = new Label(
												personalAppGroup, SWT.NONE);
										descriptionLabel_1
												.setText("Description :");
										descriptionLabel_1.setBounds(32, 135,
												60, 15);
									}
									{
										personalAppDescr_1 = new Text(
												personalAppGroup, SWT.BORDER);
										personalAppDescr_1
												.setText("Personal / Other");
										personalAppDescr_1.setEditable(false);
										personalAppDescr_1.setBounds(112, 133,
												224, 22);
									}
									{
										durationLabel = new Label(
												personalAppGroup, SWT.NONE);
										durationLabel.setText("Duration:");
										durationLabel
												.setBounds(32, 108, 45, 15);
									}
									{
										minutesLabel_1 = new Label(
												personalAppGroup, SWT.NONE);
										minutesLabel_1.setText("minutes");
										minutesLabel_1.setBounds(171, 109, 65,
												15);
									}
									{
										cancelButton = new Button(
												personalAppGroup, SWT.NONE);
										cancelButton.setText("Cancel");
										cancelButton.setBounds(360, 36, 70, 21);
										cancelButton
												.addSelectionListener(new SelectionAdapter() {
													public void widgetSelected(
															SelectionEvent evt) {
														updateCalendar();
													}
												});
									}
									{
										deleteAppointmentButton = new Button(
												personalAppGroup, SWT.NONE);
										deleteAppointmentButton
												.setText("Delete appointment");
										deleteAppointmentButton.setBounds(30,
												36, 110, 21);
										deleteAppointmentButton
												.addSelectionListener(new SelectionAdapter() {
													public void widgetSelected(
															SelectionEvent evt) {
														MessageBox message = new MessageBox(
																PlatformUI
																		.getWorkbench()
																		.getActiveWorkbenchWindow()
																		.getShell(),
																SWT.ICON_QUESTION
																		| SWT.YES
																		| SWT.NO);
														message.setMessage("Are you sure you want to delete this personal appoiontment?");
														message.setText("Message");
														int choice = message
																.open();
														if (choice == SWT.YES) {
															if (dayTimeslotCalendar1
																	.getSelectedAppointment() instanceof PersonalAppointment) {
																PersonalAppointment app = (PersonalAppointment) dayTimeslotCalendar1
																		.getSelectedAppointment();
																AppDetailTO to = app
																		.getPersonalDairyTO();
																AppReqServiceManager
																		.getInstance()
																		.deletePersonalAppointment(
																				ClientSecurityManager
																						.getInstance()
																						.getUser(),
																				to);
																updateCalendar();
															}
														}
													}
												});
									}
									{
										details = new Text(personalAppGroup,
												SWT.MULTI | SWT.LEFT
														| SWT.READ_ONLY
														| SWT.WRAP
														| SWT.V_SCROLL
														| SWT.BORDER);
										details.setBounds(112, 165, 308, 340);
										// details.setEditable(false);
									}
									{
										label20 = new Label(personalAppGroup,
												SWT.NONE);
										label20.setText("Details:");
										label20.setBounds(32, 165, 60, 17);
									}
								}
							}
							tabFolder1.setSelection(0);
							scrolledComposite1.setMinSize(composite4
									.computeSize(SWT.DEFAULT, SWT.DEFAULT));
							scrolledComposite1.setContent(composite4);
						}
					}
				}
			}
		}
		sWTCalendar1.setCalendar(Calendar.getInstance());
	}

	private void updateCalendar() {
		actionToolbar.setVisible(false);
		composite2.setVisible(false);
		dayTimeslotCalendar1.deleteAllAppointments();
		if (user != null) {
			TNLogger.debug("User id = " + user.getId());
			RoleTO tempNurse = null;
			RoleTO[] userRoles = user.getRoles();
			for (int j = 0; j < userRoles.length; j++) {
				if (userRoles[j].getRoleType() == 1) {
					tempNurse = (RoleTO) userRoles[j];
					break;
				}
			}
			if (tempNurse != null) {
				appReqDetailsTO = null;
				PlatformUI
						.getWorkbench()
						.getActiveWorkbenchWindow()
						.getShell()
						.setCursor(
								SWTResourceManager.getCursor(SWT.CURSOR_WAIT));
				appReqDetailsTO = AppReqServiceManager
						.getInstance()
						.getAppreqsByDate(tempNurse, sWTCalendar1.getCalendar());
				PlatformUI
						.getWorkbench()
						.getActiveWorkbenchWindow()
						.getShell()
						.setCursor(
								SWTResourceManager.getCursor(SWT.CURSOR_ARROW));
				// Call server to get appreqs
				TNLogger.debug("Size of AppReqs for this date: "
						+ appReqDetailsTO.length);
				if (appReqDetailsTO != null) {
					for (int i = 0; i < appReqDetailsTO.length; i++) {
						AppDetailTO appReqTO = (AppDetailTO) appReqDetailsTO[i];
						if (appReqTO.getOriginator().getType().getId() != 1
								&& appReqTO.getOriginator().getType().getId() != 6) {
							if (appReqTO != null) {
								AppReqAppointment app = new AppReqAppointment(
										appReqTO);
								app.setDescription(appReqTO.getContactPerson()
										.getSurname()
										+ ", "
										+ appReqTO.getContactPerson()
												.getFirstName()
										+ "\nPolicy: "
										+ appReqTO.getPolicyNo());
								TNLogger.debug("Adding to calendar "
										+ app.getDescription());
								dayTimeslotCalendar1.addAppointment(app);
								// Go and add to local database appointments
								// addToLocalDB(appReqTO);
							}
						} else if (appReqTO.getOriginator().getType().getId() == 1) {
							if (appReqTO != null) {
								PersonalAppointment app = new PersonalAppointment(
										appReqTO);
								app.setDescription("Personal appointment");
								TNLogger.debug("Adding to calendar "
										+ app.getDescription());
								dayTimeslotCalendar1.addAppointment(app);
								// Go and add to local database appointments
								// addToLocalDB(appReqTO);
							}
						} else if (appReqTO.getOriginator().getType().getId() == 6) {
							if (appReqTO != null) {
								AppReqAppointment app = new AppReqAppointment(
										appReqTO);
								app.setDescription(appReqTO.getComments());
								TNLogger.debug("Adding to calendar "
										+ app.getDescription());
								dayTimeslotCalendar1.addAppointment(app);
								// Go and add to local database appointments
								// addToLocalDB(appReqTO);
							}
						}
					}
				}
			}
		}
		dayTimeslotCalendar1.updateCalendar();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPart#setFocus()
	 */
	public void setFocus() {
		//
	}

	/**
	 * Cleans up all resources created by this ViewPart.
	 */
	public void dispose() {
		super.dispose();
	}

	private void sWTCalendar1DateChanged(SWTCalendarEvent evt) {
		dayTimeslotCalendar1.setVisible(false);
		dayTimeslotCalendar1.setHeader("Calendar for "
				+ Util.getStringFromDate(sWTCalendar1.getCalendar().getTime()));
		dayTimeslotCalendar1.setDate(sWTCalendar1.getCalendar());
		updateCalendar();
		// dayTimeslotCalendar1.redraw();
		dayTimeslotCalendar1.setVisible(true);
	}

	private void calendarClicked() {
		actionToolbar.setVisible(false);
		try {
			TNLogger.debug("   timeslotcalendar event occured");
			AppDetailTO appreqPersonalApp = new AppDetailTO();
			appreqPersonalApp.setStartTimeStamp(dayTimeslotCalendar1
					.getSelectedDate().getTimeInMillis());
			Calendar cal = Calendar.getInstance();
			cal.setTime(dayTimeslotCalendar1.getSelectedDate().getTime());
			cal.add(Calendar.MINUTE, dayTimeslotCalendar1
					.getDefaultNewAppointmentTimeInMinutes());
			appreqPersonalApp.setEndTimeStamp(cal.getTimeInMillis());
			// appreqPersonalApp.getOriginator().getType()
			// .setDescription(TEMP_APP_DESCR);
			Appointment temp = new PersonalAppointment(appreqPersonalApp);
			dayTimeslotCalendar1.removeTempAppointment();
			dayTimeslotCalendar1.addTempAppointment(temp);

			composite2.setVisible(true);
			tabFolder1.setSelection(1);

			tabSelected = 1;
			if (!dayTimeslotCalendar1.isTempAppointmentIsOverlapping()) {
				if (dayTimeslotCalendar1.getSelectedAppointment() != null) {
					dateSelectedField_1.setText(Util
							.formatDateToDateTime(dayTimeslotCalendar1
									.getSelectedAppointment().getStartTime()
									.getTime()));
				}
				bookAppointmentButton_1.setVisible(true);
				cancelButton.setVisible(true);
				deleteAppointmentButton.setVisible(false);
				durationSpinner.setEnabled(true);
				bookAppointmentButton_1.setText("Book appointment");
				personalAppGroup.setVisible(true);
			} else {
				personalAppGroup.setVisible(false);
				dayTimeslotCalendar1.removeTempAppointment();
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void appointmentSelected() {
		try {
			TNLogger.debug("AppointmentSelectedEvent in timeslotcalendar event occured");
			AppDetailTO app = null;
			if (dayTimeslotCalendar1.getSelectedAppointment() instanceof AppReqAppointment) {
				app = ((AppReqAppointment) dayTimeslotCalendar1
						.getSelectedAppointment()).getAppReqDetailsTO();
			} else {
				app = ((PersonalAppointment) dayTimeslotCalendar1
						.getSelectedAppointment()).getPersonalDairyTO();
			}
			composite2.setVisible(true);
			Calendar endTime = null;
			Calendar startTime = null;
			final DayTimeslotCalendar d = dayTimeslotCalendar1;
			if (app.getOriginator().getType().getId() != 1
					&& app.getOriginator().getType().getId() != 6) {
				dayTimeslotCalendar1.removeTempAppointment();

				AppReqAppointment appointment = (AppReqAppointment) d
						.getSelectedAppointment();
				currentApp = appointment.getAppReqDetailsTO();
				endTime = appointment.getEndTime();
				startTime = appointment.getStartTime();
				tabFolder1.setSelection(0);
				tabSelected = 0;
				AppClientTO[] appClients = appointment.getAppReqDetailsTO()
						.getClients();
				clients.removeAll();
				for (int i = 0; i < appClients.length; i++) {
					clients.add(appClients[i].getPerson().getFirstName() + " "
							+ appClients[i].getPerson().getSurname() + " ["
							+ appClients[i].getClientNumber() + "]");
				}
				comments.setText(currentApp.getComments());
				venue.setText(currentApp.getLocation());
				appTime.setText(Util.formatDateToDateTime(new Date(currentApp
						.getStartTimeStamp()))
						+ " to "
						+ Util.formatDateToDateTime(new Date(currentApp
								.getEndTimeStamp())));
				try {
					String contactDetails = currentApp.getContactPerson()
							.getFirstName()
							+ " "
							+ currentApp.getContactPerson().getSurname()
							+ "\n"
							+ "(c)  "
							+ currentApp.getContactPerson().getContactDetails()
									.getCellNo()
							+ "\n"
							+ "(w)  "
							+ currentApp.getContactPerson().getContactDetails()
									.getWorkPhoneNo()
							+ "\n"
							+ "(h)  "
							+ currentApp.getContactPerson().getContactDetails()
									.getHomePhoneNo();
					contactPerson.setText(contactDetails);
				} catch (Exception e) {

				}
				try {
					broker.setText(currentApp.getBroker());
				} catch (Exception e) {
					broker.setText("");
				}
				try {
					branch.setText(currentApp.getBranch());
				} catch (Exception e) {
					branch.setText("");
				}
				try {
					dc.setText(currentApp.getOriginator().getDc().getUser()
							.getUsername());
				} catch (Exception e) {
					dc.setText("");
				}
				clientDetailsComposite.setVisible(false);
				formselectionComposite.setVisible(false);
				if (appClients.length == 1) {
					clients.select(0);
					clientsWidgetSelected(null);
				}
				actionToolbar.setVisible(true);
				newComments.setText("");
				// ClientWindowManager.getInstance().enableActionMenu();
			} else if (app.getOriginator().getType().getId() == 1) {
				PersonalAppointment appointment = (PersonalAppointment) d
						.getSelectedAppointment();
				endTime = appointment.getEndTime();
				startTime = appointment.getStartTime();
				tabFolder1.setSelection(1);
				tabSelected = 1;
				String start = Util.formatDateToDateTime(startTime.getTime());
				String end = Util.formatDateToDateTime(endTime.getTime());
				end = end.substring(end.length() - 5, end.length());
				String displayDateTimeApp = " " + start + " to " + end;

				dateSelectedField_1.setText(displayDateTimeApp);
				bookAppointmentButton_1.setVisible(false);
				cancelButton.setVisible(false);
				deleteAppointmentButton.setVisible(true);
				durationSpinner.setEnabled(false);
				bookAppointmentButton_1.setText("Update appointment");
				// ClientWindowManager.getInstance().disableActionMenu();
			} else if (app.getOriginator().getType().getId() == 6) {
				AppReqAppointment appointment = (AppReqAppointment) d
						.getSelectedAppointment();
				endTime = appointment.getEndTime();
				startTime = appointment.getStartTime();
				tabFolder1.setSelection(1);
				tabSelected = 1;
				String start = Util.formatDateToDateTime(startTime.getTime());
				String end = Util.formatDateToDateTime(endTime.getTime());
				end = end.substring(end.length() - 5, end.length());
				String displayDateTimeApp = " " + start + " to " + end;
				SimpleDateFormat sim = new SimpleDateFormat("HH:mm");
				details.setText(appointment.getDescription() + "\n"
						+ appointment.getSuburb() + "\n"
						+ appointment.getAppLocation() + "\n Time:"
						+ sim.format(appointment.getStartTime().getTime())
						+ " to "
						+ sim.format(appointment.getEndTime().getTime()));
				dateSelectedField_1.setText(displayDateTimeApp);
				bookAppointmentButton_1.setVisible(false);
				cancelButton.setVisible(false);
				deleteAppointmentButton.setVisible(false);
				durationSpinner.setEnabled(false);
				bookAppointmentButton_1.setText("Update appointment");
				// ClientWindowManager.getInstance().disableActionMenu();
			}

			// appointmentSelectedEvent
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	/**
	 * Used when duration is changed on the screen to update the appointment and
	 * do validation.
	 * 
	 */
	private void updateTempAppointment() {
		TNLogger.debug("updateTempAppointment temp app removed");
		AppDetailTO appreqPersonalApp = new AppDetailTO();
		appreqPersonalApp.setStartTimeStamp(dayTimeslotCalendar1
				.getSelectedDate().getTimeInMillis());
		Calendar cal = Calendar.getInstance();
		cal.setTime(dayTimeslotCalendar1.getSelectedDate().getTime());
		cal.add(Calendar.MINUTE,
				dayTimeslotCalendar1.getDefaultNewAppointmentTimeInMinutes());
		appreqPersonalApp.setEndTimeStamp(cal.getTimeInMillis());
		// appreqPersonalApp.setDiaryTypeDesc(TEMP_APP_DESCR);
		Appointment temp = new PersonalAppointment(appreqPersonalApp);
		dayTimeslotCalendar1.removeTempAppointment();
		dayTimeslotCalendar1.addTempAppointment(temp);
		if (dayTimeslotCalendar1.isTempAppointmentIsOverlapping()) {
			MessageBox message = new MessageBox(PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow().getShell(), SWT.ICON_WARNING
					| SWT.OK);
			message.setMessage("Personal Appointment is overlapping an existing appointment, please select another time.");
			message.setText("Message");
			message.open();
			dayTimeslotCalendar1.removeTempAppointment();
			personalAppGroup.setVisible(false);
			dayTimeslotCalendar1
					.setDefaultNewAppointmentTimeInMinutes(DEFAULT_TIMESLOT);
			durationSpinner.setSelection(DEFAULT_TIMESLOT);
		}
	}

	private void tabFolder1WidgetSelected(SelectionEvent evt) {
		tabFolder1.setSelection(tabSelected);
	}

	private AppClientTO getSelectedClient(AppClientTO[] cl) {
		String client = clients.getSelection()[0];
		for (int i = 0; i < cl.length; i++) {
			String temp = cl[i].getPerson().getFirstName() + " "
					+ cl[i].getPerson().getSurname() + " ["
					+ cl[i].getClientNumber() + "]";
			if (temp.equalsIgnoreCase(client)) {
				return cl[i];
			}
		}
		return null;
	}

	private void clientsWidgetSelected(SelectionEvent evt) {

		// Fill details of client selected
		currentClient = getSelectedClient(currentApp.getClients());
		clientDetailsComposite.setVisible(true);
		formselectionComposite.setVisible(true);
		referenceNumber.setText("" + currentClient.getId());
		name.setText(currentClient.getPerson().getFirstName() + " "
				+ currentClient.getPerson().getSurname());
		/*
		 * contactDetails.setText("Cellphone:" +
		 * currentClient.getPerson().getContactDetails().getCellNo() + "\n Work
		 * telephone:
		 * " + currentClient.getPerson().getContactDetails() .getWorkPhoneNo() + "
		 * \n Home telephone: " + currentClient.getPerson().getContactDetails()
		 * .getHomePhoneNo());
		 */
		contactDetails.setText("(c)  "
				+ currentClient.getPerson().getContactDetails().getCellNo()
				+ "\n(w)  "
				+ currentClient.getPerson().getContactDetails()
						.getWorkPhoneNo()
				+ "\n(h)  "
				+ currentClient.getPerson().getContactDetails()
						.getHomePhoneNo());
		if (currentClient.getPerson().getLanguage().equalsIgnoreCase("A")) {
			lanAfr.setSelection(true);
			lanEng.setSelection(false);
		} else {
			lanEng.setSelection(true);
			lanAfr.setSelection(false);
		}
		policyNumber.setText((currentClient.getPolicyAlpha() + currentClient
				.getPolicyNumber()).trim());
		idNumber.setText(currentClient.getPerson().getIdNumber());
		clientNumber.setText(currentClient.getPerson().getClientNumber());
		try {
			additionalRequirements.setText(currentApp.getExtraRequirements());
		} catch (Exception e) {
			additionalRequirements.setText("");
		}
		interactive.setText(currentApp.isInteractive() ? "Yes" : "No");
		forms.removeAll();

		// Remove doubles when medperson has done multiple app done events
		// (display only unique forms descriptions)
		Map uniqueReqs = new HashMap();
		for (int i = 0; i < currentClient.getRequirements().length; i++) {
			if (currentClient.getRequirements()[i].getFormNo()
					.indexOf("UNDERW") == -1) {
				continue;
			}
			uniqueReqs.put(currentClient.getRequirements()[i].getDescription(),
					currentClient.getRequirements()[i]);
		}

		Map groups = new HashMap();
		Iterator it = uniqueReqs.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry entry = (Map.Entry) it.next();
			RequirementTO req = (RequirementTO) entry.getValue();
			if (isARequirementHidden(req)) {
				continue;
			}

			String desc = req.getDescription();
			String formName = req.getFormNo();
			formName = "Form: " + formName + "  ";
			if (groups.keySet().contains(formName)) {
				Collection col = (Collection) groups.get(formName);
				col.add(desc);
			} else {
				Collection col = new ArrayList();
				col.add(desc);
				groups.put(formName, col);
			}
		}

		for (Iterator iter = groups.keySet().iterator(); iter.hasNext();) {
			String key = (String) iter.next();
			Collection el = (Collection) groups.get(key);
			forms.add(key);
			for (Iterator iterator = el.iterator(); iterator.hasNext();) {
				String element = (String) iterator.next();
				forms.add("         " + element);
			}
		}
	}

	private boolean isARequirementHidden(RequirementTO req) {
		return (req.getGroup().equals("Additional") && !(user.getId() + "")
				.equals(req.getMedPerson()));
	}

	private void toolItem2WidgetSelected(SelectionEvent evt) {

		String selectedForm = forms.getSelection()[0];
		// selectedForm = getFormName(selectedForm);

		String formNo = getFormNo(selectedForm);

		// Clipboard clipboard = new
		// Clipboard(PlatformUI.getWorkbench().getDisplay());
		// String textData = "" + currentClient.getId();
		// String rtfData = "{\\rtf1\\b\\i Client refno}";
		// TextTransfer textTransfer = TextTransfer.getInstance();
		// RTFTransfer rtfTransfer = RTFTransfer.getInstance();
		// Transfer[] transfers = new Transfer[] { textTransfer, rtfTransfer };
		// Object[] data = new Object[] { textData, rtfData };
		// clipboard.setContents(data, transfers);
		// clipboard.dispose();
		// PdfFileManager.openPdfTemplate(currentClient.getClientNumber(),
		// selectedForm, currentClient.getPerson()
		// .getLanguage());
		PdfFileManager.openPdfTemplate(currentClient.getClientNumber(), formNo,
				currentClient.getPerson().getLanguage(), currentClient.getId());
	}

	private String getFormName(String selection) {
		String subs = "";
		selection = selection.trim();
		try {
			subs = selection.substring(selection.indexOf("UNDERW"),
					selection.indexOf("UNDERW") + 9);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return subs;
	}

	private String getFormNo(String formName) {
		return PdfFileManager.getFormNo(formName);
	}

	public AppDetailTO getCurrentApp() {
		return currentApp;
	}

	public void reloadDay() {
		actionToolbar.setVisible(false);
		sWTCalendar1.setCalendar(sWTCalendar1.getCalendar());
	}

	private void appointmentDoneWidgetSelected(SelectionEvent evt) {

		// Show message to MedPerson explaining submit process
		String messageText = "All completed forms will now be uploaded to the Momentum Head Office server. "
				+ "\n\n* This process is dependant on the speed and availability of your data connection. If no connectivity "
				+ "can be established, the Appointment Done process will be moved to a background queue, which retries submitting the forms every 2 minutes. "
				+ "\n\n* Please do not close and exit this program untill you have received a confirmation message box with the "
				+ "message 'Appointment sent to server'. In the event that the program is closed before the confirmation box was received the queue will terminate, "
				+ "and you will need to reopen the appointment and click on the 'Appointment done' action again."
				+ "\n\n* You can minimize this program or open other programs, as the queue will retry to submit the completed forms in the background."
				+ "\n\n* You can also view the queue and messages by going to the File menu above and selecting 'View all outstanding requests'";
		MessageBox message = new MessageBox(ClientWindowManager.getInstance()
				.getShell(), SWT.OK + SWT.ICON_INFORMATION);
		message.setMessage(messageText);
		message.setText("Important information regarding the Appointment Done process");
		message.open();

		updateCurrentDetails();
		AppointmentDoneAction action = new AppointmentDoneAction();
		try {
			action.runManaged(null, this, ClientSecurityManager.getInstance()
					.getUser(), ClientSecurityManager.getInstance()
					.getLoggedInUser());
		} catch (Exception e) {
			TNLogger.error("Appointment Done exception " + e);
		}
	}

	private void viewFormsWidgetSelected(SelectionEvent evt) {

		try {
			ImagesDialog id = new ImagesDialog(Display.getCurrent()
					.getActiveShell(), SWT.APPLICATION_MODAL, currentApp);
			id.open();

		} catch (TimedRunException toe) {
			if (toe.getCause() instanceof ProcessingException) {
				new ErrMessage()
						.showUserDefinedMessage("Fastlane Service is not available, please check your connection.");
				return;
			}
			new ErrMessage().showATechnicalErrorHasOccured();
		} finally {
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell()
					.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_ARROW));
		}
	}

	private void updateCurrentDetails() {
		String newCommentsText = newComments.getText();
		if (!additionForms.isEmpty()) {
			newCommentsText += "\nADDED additional form(s): " + additionForms;
			additionForms.clear();
		}

		currentApp.setNewComments(newCommentsText.trim());
		// currentApp.setComments(currentApp.getComments().trim());
		// currentApp.setComments(currentApp.getComments() + "\n" +
		// newComments.getText());
		if (currentClient != null) {
			AppClientTO[] clients = currentApp.getClients();
			for (int i = 0; i < clients.length; i++) {
				if (clients[i].getClientNumber().equalsIgnoreCase(
						currentClient.getClientNumber())) {
					// update language
					// only thing that can be updated
					if (lanAfr.getSelection()) {
						clients[i].getPerson().setLanguage("A");
					} else {
						clients[i].getPerson().setLanguage("E");
					}
				}
			}
			currentApp.setClients(clients);
		}
	}

	private void requestComments(String dialogTitle, String methodName) {
		TitleAreaDialog dialog = new TitleAreaDialog(Display.getCurrent()
				.getActiveShell()) {
			Text comments;

			@Override
			protected Control createDialogArea(Composite parent) {
				Composite area = (Composite) super.createDialogArea(parent);
				Composite container = new Composite(area, SWT.NONE);
				container.setLayoutData(new GridData(GridData.FILL_BOTH));

				comments = new Text(container, SWT.V_SCROLL | SWT.MULTI
						| SWT.BORDER | SWT.WRAP);
				comments.setTextLimit(1024);
				comments.setBounds(5, 6, 447, 98);
				comments.setText(newComments.getText());

				return area;
			}

			@Override
			protected Point getInitialSize() {
				return new Point(464, 250);
			}

			@Override
			protected void okPressed() {
				newComments.setText(comments.getText());
				super.okPressed();
			}
		};
		dialog.create();

		dialog.setTitle(dialogTitle + " (close appointment)");
		dialog.setMessage("Please enter A-code comments");

		Shell shell = dialog.getShell();
		shell.setText(Application.APPLICATION_NAME);
		shell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(),
				"icons/logo-m.gif"));

		if (dialog.open() == Window.OK) {
			updateCurrentDetails();
			try {
				Method action = AppReqServiceManager.class.getMethod(
						methodName, UserTO.class, UserTO.class,
						AppDetailTO.class);
				action.invoke(AppReqServiceManager.getInstance(),
						ClientSecurityManager.getInstance().getUser(),
						ClientSecurityManager.getInstance().getLoggedInUser(),
						currentApp);
			} catch (Exception e) {
				TNLogger.fatal("failed to call " + methodName);
			}
			sWTCalendar1.setCalendar(sWTCalendar1.getCalendar());
		}
	}

	private void clientCancelledBtnWidgetSelected(SelectionEvent evt) {
		requestComments("Client Cancelled", "setClientCancelledAction");
	}

	private void clientDeclinedBtnWidgetSelected(SelectionEvent evt) {
		requestComments("Client Declined", "setClientDeclinedAction");
	}

	private void nurseCancelledBtnWidgetSelected(SelectionEvent evt) {
		requestComments("Nurse Cancelled", "setNurseCancelledAction");
	}

	private void updateDetailsBtnWidgetSelected(SelectionEvent evt) {
		updateCurrentDetails();
		AppReqServiceManager.getInstance().saveAppReq(
				ClientSecurityManager.getInstance().getUser(),
				ClientSecurityManager.getInstance().getLoggedInUser(),
				currentApp);
		sWTCalendar1.setCalendar(sWTCalendar1.getCalendar());
	}

	private void rescheduleAppointmentBtnWidgetSelected(SelectionEvent evt) {
		updateCurrentDetails();
		RescheduleAppointmentWizzard wizzard = new RescheduleAppointmentWizzard(
				currentApp);
		wizzard.run();
		if (wizzard.getReturnCode() != IDialogConstants.CANCEL_ID) {
			sWTCalendar1.setCalendar(sWTCalendar1.getCalendar());
		}
	}

	private void viewFormsInWorkFolder(SelectionEvent evt) {

		try {
			String clientNumber = currentClient.getClientNumber();
			String pdfWorkDir = PdfFileManager.getWorkDirectory();

			String pathToForms = pdfWorkDir + clientNumber;

			// Check if the folder already exists, if not, create it
			File clientWorkFolder = new File(pathToForms);
			if (!clientWorkFolder.exists()) {
				clientWorkFolder.mkdir();
			}

			String cmd = "explorer " + pathToForms.replaceAll("/", "\\\\");
			;

			Runtime.getRuntime().exec(cmd);
		} catch (IOException e) {
			e.printStackTrace();

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	private void addAdditionalForm(SelectionEvent evt) {
		ArrayList pdfFiles = new ArrayList();

		pdfFiles = PdfFileManager.getAllPdfFileNameInDir(currentClient
				.getPerson().getLanguage());
		PdfFileChooserDialog fileChooser = new PdfFileChooserDialog(PlatformUI
				.getWorkbench().getActiveWorkbenchWindow().getShell(), pdfFiles);

		int returnCode = fileChooser.open();

		if (returnCode == IDialogConstants.OK_ID) {
			String selectedFile = fileChooser.getSelectedFile();
			if (selectedFile != null) {
				RequirementTO newReq = new RequirementTO();
				newReq.setClient(currentClient);
				// newReq.setCode(getFormName(selectedFile));
				// newReq.setCode(getFormNo(selectedFile));
				newReq.setCode("Additional");
				newReq.setDate(Calendar.getInstance());
				newReq.setDescription("Additional: " + selectedFile);

				newReq.setFormNo(getFormName(selectedFile));
				newReq.setGroup("Additional");

				newReq.setMedPerson(user.getId() + ""); // overload field
				additionForms.add(selectedFile);

				RequirementTO[] oldReqs = currentClient.getRequirements();
				RequirementTO[] newReqs = new RequirementTO[oldReqs.length + 1];
				for (int i = 0; i < oldReqs.length; i++) {
					newReqs[i] = oldReqs[i];
				}
				newReqs[newReqs.length - 1] = newReq;
				currentClient.setRequirements(newReqs);
				forms.removeAll();
				Map groups = new HashMap();
				for (int i = 0; i < currentClient.getRequirements().length; i++) {
					if (isARequirementHidden(currentClient.getRequirements()[i])) {
						continue;
					}

					String desc = currentClient.getRequirements()[i]
							.getDescription();
					String formName = currentClient.getRequirements()[i]
							.getFormNo();
					formName = "Form: " + formName + "  ";
					if (groups.keySet().contains(formName)) {
						Collection col = (Collection) groups.get(formName);
						col.add(desc);
					} else {
						Collection col = new ArrayList();
						col.add(desc);
						groups.put(formName, col);
					}
				}
				for (Iterator iter = groups.keySet().iterator(); iter.hasNext();) {
					String key = (String) iter.next();
					Collection el = (Collection) groups.get(key);
					forms.add(key);
					for (Iterator iterator = el.iterator(); iterator.hasNext();) {
						String element = (String) iterator.next();
						forms.add("         " + element);
					}
				}
			}
		}
	}

	private java.util.List<String> additionForms = new ArrayList<String>();

	boolean loaded;

	private void loadAppointmentsBtnWidgetSelected(SelectionEvent evt) {
		loaded = true;

		ContinuousProgressBar prog = new ContinuousProgressBar(
				PlatformUI.isWorkbenchRunning() ? PlatformUI.getWorkbench()
						.getActiveWorkbenchWindow().getShell() : new Shell(),
				SWT.NULL, new ProgressAction() {
					public void executeAction() {
						TNLogger.debug("Start loading apps for the day");
						for (int j = 0; j < appReqDetailsTO.length; j++) {
							AppDetailTO appReqTO = appReqDetailsTO[j];
							AppClientTO[] clients = appReqTO.getClients();
							for (int x = 0; x < clients.length; x++) {
								AppClientTO client = clients[x];
								final long refno = client.getId();
								// RequirementTO[] meds =
								// client.getRequirements();
								// //EFormServiceServiceLocator loc = new
								// EFormServiceServiceLocator();
								// // loc.setCacheWSDL(false);
								try {

									EFormService service = EFormServiceRest
											.getInstance();

									FormDTO formData = service
											.getFormData(refno);
									TNLogger.debug("successfully got form data from webservice");

									DBHelper.AddEForm(formData, refno);
									//
									// //final EFormService serv =
									// loc.getEFormService();
									//
									// final EFormService service;
									//
									// // Get service locator wsdl
									// String wsdl =
									// ClientProperties.getInstance().getProperty("fastlane.eFormService");
									//
									// // Create service locator
									// EFormServiceServiceLocator sl = new
									// EFormServiceServiceLocator();
									//
									// try {
									// // Get service from service locator
									// service = sl.getEFormService(new
									// URL(wsdl));
									//
									// } catch (MalformedURLException e) {
									// throw new RuntimeException(e);
									// }
									//
									// for (int i = 0; i < meds.length; i++) {
									// TNLogger.debug("Form no=" +
									// meds[i].getFormNo());
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW003"))
									// {
									// BaseForm form =
									// service.prePopulatePathReq(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW001")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW002")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW004")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW022")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW024")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW027")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW028")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW029")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW030")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW031")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW032")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW033")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW034")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW050")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW051")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW052")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW060")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW061")
									//
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW082"))
									// {
									// BaseForm form =
									// service.prePopulateBasicPersonalDetails(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW006")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW067"))
									// {
									// BaseForm form =
									// service.prePopulateShortMedical(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW021")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW025"))
									// {
									// BaseForm form =
									// service.prePopulateNurseDetails(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW062"))
									// {
									// BaseForm form =
									// service.prePopulateForeignInsured(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW063"))
									// {
									// BaseForm form =
									// service.prePopulateOutsideResidence(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW065"))
									// {
									// BaseForm form =
									// service.prePopulateFullPersonalDetails(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// if
									// (meds[i].getFormNo().equalsIgnoreCase("UNDERW080")
									// ||
									// meds[i].getFormNo().equalsIgnoreCase("UNDERW081"))
									// {
									// BaseForm form =
									// service.prePopulateFinancial(refno);
									// DBHelper.AddEForm(form, refno);
									// }
									// }
								} catch (Exception e1) {
									TNLogger.error("Addtolocal db error"
											+ e1.getMessage());
									loaded = false;
								}
							}
							AppDetailTO app = null;
							// AppReqServiceServiceLocator loc = new
							// AppReqServiceServiceLocator();
							// AppReqService serv;

							AppReqService service = AppReqServiceRest
									.getInstance();

							try {

								// serv = loc.getAppReqService();
								app = service.getAppDetails(
										ClientSecurityManager.getInstance()
												.getUser().getUsername(),
										appReqTO.getId());

							} catch (EntityNotFoundException e) {
								TNLogger.error("Entity not found exception "
										+ e.getMessage());
								loaded = false;
							} catch (AppReqLockedException e) {
								TNLogger.error("Appreqlocked exception "
										+ e.getMessage());
								loaded = false;
							} catch (ProcessingException e) {
								TNLogger.error("Remote exception "
										+ e.getMessage());
								loaded = false;
							}
							// First try and delete the appreq from the db
							try {
								DBHelper.DeleteAppReq(app,
										ClientSecurityManager.getInstance()
												.getUser().getUsername());
							} catch (Exception e) {
								TNLogger.error("Delete of appreq failed"
										+ e.getMessage());
							}

							// Now add the appreq
							DBHelper.AddAppReq(app, ClientSecurityManager
									.getInstance().getUser().getUsername());
						}
					}
				});
		prog.setHeadingDescription(Application.APPLICATION_NAME);
		prog.setActionDescription("Busy loading appointments, please wait . . .");
		try {
			prog.open();
		} catch (Exception e) {
			loaded = false;
		}
		if (prog.isCancelled()) {
			loaded = false;
		}
		if (loaded) {
			MessageBox message = new MessageBox(ClientWindowManager
					.getInstance().getShell(), SWT.OK + SWT.ICON_INFORMATION);
			message.setMessage("Appointments successfully loaded to local database for "
					+ sWTCalendar1.getCalendar().getTime());
			message.setText("Loaded appointments");
			message.open();
		} else {
			MessageBox message = new MessageBox(ClientWindowManager
					.getInstance().getShell(), SWT.OK | SWT.ICON_ERROR);
			message.setMessage("Appointment loading process failed.  Please check connectivity and retry!");
			message.setText("Error");
			message.open();
		}
	}

	private void formsMouseDoubleClick(MouseEvent evt) {

		toolItem2WidgetSelected(null);

	}
}
