package za.co.momentum.recurring.nurse.client.ui;

import java.util.HashMap;
import java.util.Iterator;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;
import com.swtdesigner.ResourceManager;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.model.ParameterHolder;
import za.co.momentum.recurring.nurse.client.sao.suburb.SuburbServiceManager;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import za.co.momentum.recurring.nurse.client.ui.tools.ListBoxSelector;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.SuburbTO;

public class NurseSelection extends Dialog {

	private Logger LOG = Logger.getLogger(NurseSelection.class);
	private List list_2;
	private List regions;
	private List list;
	private Button openCalendarButton;
	private Button openCalendarButton2;
	private int selection;
	private HashMap nursesTO;
	
	protected Object result;

	protected Shell shell;

	public NurseSelection(Shell parent, int style) {
		super(parent, style);
	}

	public NurseSelection(Shell parent) {
		this(parent, SWT.NONE);
	}

	public Object open() {
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return result;
	}

	protected void createContents() {
		shell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		shell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/alien03.gif"));
		shell.setSize(576, 353);
		shell.setText("Select a nurse");
		shell.setLocation(getParent().getLocation().x +50, 
				getParent().getLocation().y+50); 	

		list = new List(shell, SWT.BORDER);
		list.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				openCalendarButton.setText("Open calender for " + list.getSelection()[0]);
			}
		});
		list.setBounds(5, 20, 252, 270);

		openCalendarButton = new Button(shell, SWT.NONE);
		openCalendarButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String selec = list.getSelection()[0];
				RoleTO nurse = (RoleTO) nursesTO.get(selec);
				//Add nurse to parameterholder
				ParameterHolder.getInstance().addParameter("nurse", nurse);
				shell.close();
			}
		});
		openCalendarButton.setText("Open calendar");
		openCalendarButton.setBounds(5, 295, 252, 24);

		regions = new List(shell, SWT.V_SCROLL | SWT.BORDER);
		regions.select(1);
		regions.setBounds(299, 20, 252, 125);
		regions.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (Character.isLetterOrDigit(e.character)) {
					String text = ListBoxSelector.getInstance().getTypedText(e.character);
					String[] items = regions.getItems();
					for (int i = 0; i < items.length; i++) {
						if (items[i].startsWith(text.toUpperCase())) {
							selection = i;
							break;
						}
					}
				} else {
					if (e.keyCode == 16777217) {
						selection = selection - 1;
					}
					if (e.keyCode == 16777218) {
						selection = selection + 1;
					}
				}
				regions.select(selection);
			}
		});
		
		regions.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				regions.select(selection);
				regions.showSelection();
			}
		});
		
		regions.addMouseListener(new MouseAdapter() {
			public void mouseDown(MouseEvent e) {
				selection = regions.getSelectionIndex();
			}
		});

		openCalendarButton2 = new Button(shell, SWT.NONE);
		openCalendarButton2.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String selec = list_2.getSelection()[0];
				RoleTO nurse = (RoleTO) nursesTO.get(selec);
				//Add nurse to parameterholder
				ParameterHolder.getInstance().addParameter("nurse", nurse);
				shell.close();
			}
		});
		openCalendarButton2.setText("Open calendar");
		openCalendarButton2.setBounds(299, 295, 252, 24);

		list_2 = new List(shell, SWT.BORDER);
		list_2.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				openCalendarButton2.setText("Open calender for " + list_2.getSelection()[0]);
			}
		});
		list_2.setBounds(299, 201, 252, 89);

		final Label allNursesOnLabel = new Label(shell, SWT.NONE);
		allNursesOnLabel.setText("All nurses on system");
		allNursesOnLabel.setBounds(4, 3, 106, 16);

		final Label searchNursesPerLabel = new Label(shell, SWT.NONE);
		searchNursesPerLabel.setText("Search nurses per region");
		searchNursesPerLabel.setBounds(299, 4, 123, 20);

		final Label nursesForRegionLabel = new Label(shell, SWT.NONE);
		nursesForRegionLabel.setText("Nurses for region ");
		nursesForRegionLabel.setBounds(299, 187, 177, 15);

		final Button getNursesForButton = new Button(shell, SWT.NONE);
		getNursesForButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				//Populate nurses for the selected region into listbox
				RoleTO[] nurses = UserServiceManager.getInstance().getNursesNySuburb(SuburbServiceManager.getInstance().getSuburb(regions.getSelection()[0]));
				LOG.debug("Nurses return is " + nurses );
				list_2.removeAll();
				for (int i = 0; i < nurses.length; i++) {
					list_2.add(nurses[i].getUser().getFirstName() + " " + nurses[i].getUser().getSurname());
					nursesTO.put(nurses[i].getUser().getFirstName() + " " + nurses[i].getUser().getSurname(), nurses[i]);
				}
				
			}
		});
		getNursesForButton.setText("Get nurses for selected region");
		getNursesForButton.setBounds(299, 155, 252, 24);

		final Label label = new Label(shell, SWT.SEPARATOR);
		label.setAlignment(SWT.CENTER);
		label.setBounds(275, 2, 7, 323);
		//
		doActions();
	}
	
	private void doActions(){
		nursesTO = new HashMap();
		java.util.List subs = SuburbServiceManager.getInstance().getSuburbList();
		for (Iterator iter = subs.iterator(); iter.hasNext();) {
			SuburbTO element = (SuburbTO) iter.next();
			regions.add(element.getSuburbName());
		}
		RoleTO[] nurses = UserServiceManager.getInstance().getNurses();
		for (int i = 0; i < nurses.length; i++) {
			list.add(nurses[i].getUser().getFirstName() + " " + nurses[i].getUser().getSurname());
			nursesTO.put(nurses[i].getUser().getFirstName() + " " + nurses[i].getUser().getSurname(), nurses[i]);
		}
		
	}

}
