package za.co.momentum.recurring.nurse.client.ui;

import java.util.Calendar;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.model.ParameterHolder;
import com.swtdesigner.ResourceManager;

public class SelectRequests extends TitleAreaDialog {
	private Text alphaNumber;
	private Text idNumber;
	private Text dob;
	private Text surname;
	private Text policyNumber;
	private Text name;

	public SelectRequests(Shell parentShell) {
		super(parentShell);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		final Composite composite = new Composite(container, SWT.NONE);
		composite.setBounds(0, 0, 494, 162);
		final Label nameLabel = new Label(composite, SWT.NONE);
		nameLabel.setText("Name");
		nameLabel.setBounds(11, 8, 67, 16);
		final Label policyNumberLabel = new Label(composite, SWT.NONE);
		policyNumberLabel.setText("Policy number");
		policyNumberLabel.setBounds(11, 131, 67, 16);
		final Label surnameLabel = new Label(composite, SWT.NONE);
		surnameLabel.setText("Surname");
		surnameLabel.setBounds(11, 32, 67, 16);
		name = new Text(composite, SWT.BORDER);
		name.setText("*");
		name.setBounds(116, 5, 363, 20);
		surname = new Text(composite, SWT.BORDER);
		surname.setText("*");
		surname.setBounds(116, 30, 363, 20);
		policyNumber = new Text(composite, SWT.BORDER);
		policyNumber.setText("*");
		policyNumber.setBounds(116, 131, 363, 20);
		final Label dateOfBirthLabel = new Label(composite, SWT.NONE);
		dateOfBirthLabel.setText("Date of birth");
		dateOfBirthLabel.setBounds(11, 56, 68, 16);
		dob = new Text(composite, SWT.BORDER);
		dob.setText("*");
		dob.setBounds(116, 55, 181, 20);
		final Label idNumberLabel = new Label(composite, SWT.NONE);
		idNumberLabel.setText("ID Number");
		idNumberLabel.setBounds(11, 80, 63, 17);
		idNumber = new Text(composite, SWT.BORDER);
		idNumber.setText("*");
		idNumber.setBounds(116, 80, 363, 20);
		final Label yyyymmddLabel = new Label(composite, SWT.NONE);
		yyyymmddLabel.setText("yyyy/mm/dd");
		yyyymmddLabel.setBounds(305, 55, 60, 15);
		final Label alphaNumberLabel = new Label(composite, SWT.NONE);
		alphaNumberLabel.setText("Policy Alpha number");
		alphaNumberLabel.setBounds(11, 107, 100, 15);
		alphaNumber = new Text(composite, SWT.BORDER);
		alphaNumber.setText("*");
		alphaNumber.setBounds(116, 105, 363, 20);
		setTitle("Search for a appointment request");
		setMessage("Wild card characters is allowed (*)");
		//
		composite.setTabList(new Control[] { name, surname, dob, idNumber,
				alphaNumber, policyNumber });
		return area;
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.CANCEL_ID, "&Cancel", true);
		createButton(parent, IDialogConstants.OK_ID, "&Search", true);
	}

	protected Point getInitialSize() {
		return new Point(502, 335);
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Momentum travelling nurse administration system");
		newShell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(),
				"icons/images.jpg"));
	}

	protected void buttonPressed(int buttonId) {
		if (buttonId == IDialogConstants.CANCEL_ID) {
			// ClientWindowManager.getInstance().setSearchHistory(false);
			// ClientWindowManager.getInstance().setSearchRequests(false);
		}
		if (buttonId == IDialogConstants.OK_ID) {
			ParameterHolder.getInstance().addParameter("name", name.getText());
			ParameterHolder.getInstance().addParameter("surname", surname.getText());
			ParameterHolder.getInstance()
					.addParameter("idnumber", idNumber.getText());
			ParameterHolder.getInstance().addParameter("policynumber",
					policyNumber.getText());
			ParameterHolder.getInstance().addParameter("alphanumber",
					alphaNumber.getText());
			if (dob.getText().equalsIgnoreCase("*")) {
				ParameterHolder.getInstance().addParameter("dob", new Long(0));
			} else {
				int year = Integer.parseInt(dob.getText().substring(0, 4));
				int month = Integer.parseInt(dob.getText().substring(5, 6));
				int day = Integer.parseInt(dob.getText().substring(8, 9));

				Calendar cal = Calendar.getInstance();
				cal.set(Calendar.YEAR, year);
				cal.set(Calendar.MONTH, month);
				cal.set(Calendar.DATE, day);
				ParameterHolder.getInstance().addParameter("dob",
						new Long(cal.getTime().getTime()));
			}
		}
		super.buttonPressed(buttonId);
	}
}
