package za.co.momentum.recurring.nurse.client.ui;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import za.co.momentum.recurring.nurse.util.RoleComparator;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import com.swtdesigner.ResourceManager;

import java.util.Arrays;

public class SelectThirdParty extends TitleAreaDialog {
	private Table table;
	private RoleTO[] nurses;

	public EventBroker userSelectedEvent = new EventBroker();

	private void addNurses(RoleTO[] nurses) {
		if (nurses == null) {
			return;
		}
		
		Arrays.sort(nurses, new RoleComparator());
		
		for (int i = 0; i < nurses.length; i++) {
			TableItem tableItem = new TableItem(table, SWT.NONE);
			tableItem.setText(0, nurses[i].getUser().getUsername());
			tableItem.setText(1, nurses[i].getUser().getFirstName());
			tableItem.setText(2, nurses[i].getUser().getSurname());
			tableItem.setText(3, nurses[i].getType());
		}
	}

	public SelectThirdParty(Shell parentShell) {
		super(parentShell);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));

		table = new Table(container, SWT.FULL_SELECTION | SWT.BORDER);
		table.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				buttonPressed(IDialogConstants.OK_ID);
			}
		});
		table.setBounds(5, 5, 482, 220);
		table.setLinesVisible(true);
		table.setHeaderVisible(true);

		final TableColumn username = new TableColumn(table, SWT.NONE);
        username.setWidth(100);
		username.setText("Username");

		final TableColumn firstname = new TableColumn(table, SWT.NONE);
        firstname.setWidth(110);
		firstname.setText("Firstname");

		final TableColumn surname = new TableColumn(table, SWT.NONE);
        surname.setWidth(130);
		surname.setText("Surname");

		final TableColumn role = new TableColumn(table, SWT.NONE);
        role.setWidth(120);
        role.setText("Role");
		setTitle("Please select Third Party you would like to transact on behalf of");
		setMessage("Select and press OK to continue");

        doSearch();

		return area;
	}

	private void doSearch() {
		table.removeAll();
		nurses = UserServiceManager.getInstance().getAllThirdPartyNurses();
		addNurses(nurses);
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
	}

	protected Point getInitialSize() {
		return new Point(500, 375);
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Select Third Party");
		newShell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/images.jpg"));
	}

	protected void buttonPressed(int buttonId) {
		TableItem[] selected = table.getSelection();		
		if (selected.length > 0) {
			UserTO user = null;
			for (final RoleTO nurs : nurses) {
				if (nurs.getUser().getUsername().equals(selected[0].getText(0))) {
					user = nurs.getUser();
					break;
				}
			}
			userSelectedEvent.notifyObservers(user);
			close();
        }
	}
}
