package za.co.momentum.recurring.nurse.client.ui;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.ui.event.ServiceRetryListener;
import com.swtdesigner.ResourceManager;

public class WebErrorWindow implements WindowIFace {
	private static final Logger LOG = Logger.getLogger(WebErrorWindow.class);
	private Text errorText;
	protected Shell shell;
	protected ServiceRetryListener serviceRetryListener;

	public static void main(String[] args) {
		try {
			WebErrorWindow window = new WebErrorWindow();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public WebErrorWindow(){
		createContents();
	}

	public void open() {
		final Display display = Display.getDefault();
		//createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	protected void createContents() {
		shell = new Shell(SWT.DIALOG_TRIM | SWT.SYSTEM_MODAL);
		shell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/logo-m.gif"));
		shell.setSize(360, 167);
		shell.setText("Error calling webservice");
		Display display = Display.getDefault();
		shell.setLocation((display.getBounds().width / 2) - (shell.getBounds().width / 2),
				(display.getBounds().height / 2) - (shell.getBounds().height / 2));
	
		final Button retryButton = new Button(shell, SWT.NONE);
		retryButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				fireServiceRetryListener();
			}
		});
		retryButton.setText("Retry");
		retryButton.setBounds(266, 109, 79, 25);

		errorText = new Text(shell, SWT.MULTI | SWT.READ_ONLY | SWT.WRAP);
		errorText.setBounds(15, 15, 330, 85);

		final Button cancelButton = new Button(shell, SWT.NONE);
		cancelButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				shell.dispose();
			}
		});
		cancelButton.setText("Cancel");
		cancelButton.setBounds(180, 110, 79, 25);
	}

	public String getErrorText() {
		return errorText.getText();
	}

	public void setErrorText(String errorText) {
		this.errorText.setText(errorText);
	}

	public void focus() {
		
	}

	public void hide() {
		
	}

	public void dispose() {
		shell.dispose();
	}
	
	public void addServiceRetryListener(ServiceRetryListener serviceRetryListener) {
		this.serviceRetryListener = serviceRetryListener;
	}
	
	private void fireServiceRetryListener() {
		shell.setVisible(false);
		if (serviceRetryListener != null) {
			serviceRetryListener.handleEvent();
		}
		shell.dispose();
	}

}
