package za.co.momentum.recurring.nurse.client.ui;

import java.text.SimpleDateFormat;
import java.util.Date;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class WelcomeView extends ViewPart {

  private Text datetime;
  public static final String ID = "WelcomeView";

  private Text pluginVersion;
  private Text eclipseVersion;
  private Text jre;
  private Text operatingSystem;

  public void createPartControl(Composite parent) {
    Composite container = new Composite(parent, SWT.NONE);
    container.setLayout(new FillLayout());

    final ScrolledComposite scrolledComposite = new ScrolledComposite(
        container, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);

    final Composite composite = new Composite(scrolledComposite, SWT.NONE);

    final Label travellingNurseAdministrationLabel = new Label(composite,
        SWT.NONE);
    travellingNurseAdministrationLabel.setForeground(SWTResourceManager
        .getColor(0, 128, 255));
    travellingNurseAdministrationLabel.setFont(SWTResourceManager.getFont("",
        14, SWT.BOLD | SWT.ITALIC));
    travellingNurseAdministrationLabel
        .setText("Travelling nurse administration system");
    travellingNurseAdministrationLabel.setBounds(5, 7, 421, 26);

    final Label operatingSystemLabel = new Label(composite, SWT.NONE);
    operatingSystemLabel.setText("Operating system:");
    operatingSystemLabel.setBounds(5, 56, 120, 16);

    final Label javaRuntimeEnvironmentLabel = new Label(composite, SWT.NONE);
    javaRuntimeEnvironmentLabel.setText("Java runtime environment:");
    javaRuntimeEnvironmentLabel.setBounds(5, 78, 156, 16);

    final Label versionLabel = new Label(composite, SWT.NONE);
    versionLabel.setText("Eclipse version:");
    versionLabel.setBounds(5, 100, 120, 16);

    final Label pluginVersionLabel = new Label(composite, SWT.NONE);
    pluginVersionLabel.setText("Plugin version:");
    pluginVersionLabel.setBounds(5, 125, 120, 16);

    operatingSystem = new Text(composite, SWT.READ_ONLY);
    operatingSystem.setBounds(195, 50, 232, 20);

    jre = new Text(composite, SWT.READ_ONLY);
    jre.setBounds(195, 75, 232, 20);

    eclipseVersion = new Text(composite, SWT.READ_ONLY);
    eclipseVersion.setBounds(195, 100, 232, 20);

    pluginVersion = new Text(composite, SWT.READ_ONLY);
    pluginVersion.setBounds(195, 125, 232, 20);

    final Label dateLabel = new Label(composite, SWT.NONE);
    dateLabel.setText("Date:");
    dateLabel.setBounds(5, 147, 120, 16);

    datetime = new Text(composite, SWT.READ_ONLY);
    datetime.setBounds(195, 150, 232, 20);

    final Label label = new Label(composite, SWT.NONE);
    label.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/myriadheader~1.jpg"));
    label.setBounds(5, 176, 430, 145);
    composite.setSize(494, 346);
    scrolledComposite.setContent(composite);
    //
    createActions();
    initializeToolBar();
    initializeMenu();
  }

  private void createActions() {
    operatingSystem.setText(System.getProperty("os.name") + " version "
        + System.getProperty("os.version"));
    jre.setText(System.getProperty("java.version") + " from "
        + System.getProperty("java.vendor"));
    pluginVersion.setText(getViewSite().getPluginId());
    datetime.setText(new SimpleDateFormat("yyyy - MM - dd   hh:mm:ss")
        .format(new Date()));
    eclipseVersion.setText( Platform.getProduct().getName() + "test3");
    setTitleToolTip("Welcome to the Travelling Nurse Administration System");
  }

  private void initializeToolBar() {
    IToolBarManager tbm = getViewSite().getActionBars().getToolBarManager();
  }

  private void initializeMenu() {
    IMenuManager manager = getViewSite().getActionBars().getMenuManager();
  }

  public void setFocus() {
  }

}