package za.co.momentum.recurring.nurse.client.ui.components;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class LabelEdit extends Composite {

	public static int ALIGN_RIGHT = 2;
	public static int ALIGN_LEFT = 1;
	public static int ALIGN_TOP = 3;
	public static int ALIGN_BOTTOM = 4;
	
	public static int JUST_RIGHT = 1;
	public static int JUST_LEFT = 2;
	public static int JUST_CENTER = 3;
	
	private Text textField;
	private Label label;
	private int height;
	private int width;
	private int labelAlign = 1;
	private int labelLength = 50;
	private int labelHeight = 10;
	private int labelJustification = 1;
	private boolean readOnly;
	private String labelText = "Text";
	private String editText = "Edit"; 
	
	
	public boolean isReadOnly() {
		return readOnly;
	}

	public void setReadOnly(boolean readOnly) {
		this.readOnly = readOnly;
		textField.setEditable(false);
	}

	public String getText() {
		return editText;
	}

	public void setText(String editText) {
		this.editText = editText;
		textField.setText(editText);
	}

	public String getLabelText() {
		return labelText;
	}

	public void setLabelText(String labelText) {
		this.labelText = labelText;
		label.setText(labelText);
	}

	public int getLabelLength() {
		return labelLength;
	}

	public void setLabelLength(int labelLength) {
		this.labelLength = labelLength;
		drawComponents();
	}

	public int getLabelAlign() {
		return labelAlign;
	}

//	One of ALIGN_RIGHT, ALIGN_LEFT, ALIGN_TOP, ALIGN_BOTTOM
	public void setLabelAlign(int labelAlign) {
		this.labelAlign = labelAlign;
		drawComponents();
	}

	public int getLabelHeight() {
		return labelHeight;
	}

	public void setLabelHeight(int labelHeight) {
		this.labelHeight = labelHeight;
		drawComponents();
	}
	
	public int getLabelJustification() {
		return labelJustification;
	}

	//One of SWT.LEFTALIGN, SWT.RIGHTALIGN or SWT.CENTERALIGN
	public void setLabelJustification(int labelJustification) {
		this.labelJustification = labelJustification;
		label.setAlignment(labelJustification);
	}

	public LabelEdit(Composite parent, int style) {
		super(parent, style);
		height = getSize().y;
		width = getSize().x;
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				height = getSize().y;
				width = getSize().x;
				drawComponents();
			}
		});

		label = new Label(this, SWT.WRAP);
		label.setText("Text");
		label.setBounds(0, 1, 153, 30);

		textField = new Text(this, SWT.BORDER);
	
		textField.setBounds(154, 0, 120, 30);
	}

	private void drawComponents() {
		if (labelAlign == ALIGN_RIGHT) {
			label.setLocation(width - labelLength, 0);
			label.setSize(labelLength, height);
			textField.setLocation(0, 0);
			textField.setSize(width - labelLength, height);
		} else if (labelAlign == ALIGN_TOP) {
			label.setLocation(0, 0);
			label.setSize(width, labelHeight);
			textField.setLocation(0, labelHeight);
			textField.setSize(width, height - labelHeight);
		} else if (labelAlign == ALIGN_BOTTOM) {
			label.setLocation(0, height - labelHeight);
			label.setSize(width, labelHeight);
			textField.setLocation(0, 0);
			textField.setSize(width, height - labelHeight);
		} else {
			label.setLocation(0, 0);
			label.setSize(labelLength, height);
			textField.setLocation(label.getSize().x, 0);
			textField.setSize(width - labelLength, height);
		}

	}

}
