package za.co.momentum.recurring.nurse.client.ui.components.calendar;

import java.util.Calendar;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;

public class AppReqAppointment implements Appointment {
	private AppDetailTO appreq;
	private String description;

	public AppReqAppointment(AppDetailTO appreq) {
		this.appreq = appreq;
	}

	public AppDetailTO getAppReqDetailsTO() {
		return appreq;
	}

	public Calendar getStartTime() {
		Calendar start = Calendar.getInstance();
		start.setTimeInMillis(appreq.getStartTimeStamp());
		return start;
	}

	public Calendar getEndTime() {
		Calendar end = Calendar.getInstance();
		end.setTimeInMillis(appreq.getEndTimeStamp());
		return end;
	}

	public String getDescription() {
		return description;
	}

	public void setStartTime(Calendar startTime) {
		// 
	}

	public void setEndTime(Calendar endTime) {
		// 
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getSuburb() {
		try {
			return appreq.getAddress().getSuburb().getSuburbName();
		} catch (Exception e) {
			return "";
		}
	}

	public String getAppLocation() {
		if (appreq.getLocation() != null){
			return appreq.getLocation();
		}
		return "";
	}
}
