package za.co.momentum.recurring.nurse.client.ui.components.calendar;

import java.awt.Color;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Iterator;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import com.swtdesigner.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class DayTimeslotCalendar extends Composite {
	private SimpleDateFormat sim = new SimpleDateFormat("HH:mm");
	private Calendar date = Calendar.getInstance();
	private int timeslotLengthInMinutes = 60;
	private int startHour = 6;
	private int endHour = 18;
	private int labelLength = 50;
	private int timeslotHeight = 20;
	private Color label1Color = Color.WHITE;
	private Color label2Color = Color.WHITE;
	private Color timeslot1Color = Color.WHITE;
	private Color timeslot2Color = Color.WHITE;
	private Composite calendarComposite;
	private ScrolledComposite scrolledComposite;
	private Calendar selectedDate;
	private Appointment selectedAppointment;
	private AppointmentSelectedListener selectListener;
	private SelectedDateChangedListener dateListener;
	private Label calendarheader;
	private String header = "";
	private Collection timeslots;
	private Color appointmentColor;
	private int defaultNewAppointmentTimeInMinutes = 30;
	private Font font;
	private Font headerFont;
	private Color headerBackground = Color.WHITE;
	private int snapToTime = 15;
	private boolean tempAppointmentIsOverlapping = false;
	private Collection currentAppointments;

	public DayTimeslotCalendar(Composite parent, int style) {
		super(parent, style);
		currentAppointments = new ArrayList();
		setLayout(new FillLayout());
		this.setSize(516, 375);		
		scrolledComposite = new ScrolledComposite(this, SWT.V_SCROLL);
		calendarComposite = new Composite(scrolledComposite, SWT.NONE);
		calendarComposite.setBackground(Display.getCurrent().getSystemColor(
				SWT.COLOR_WHITE));
		calendarheader = new Label(calendarComposite, SWT.NONE);
		calendarheader.setBounds(0, 0, 61, 39);
		calendarheader.setText(header);
		calendarComposite.setSize(500, 375);
		scrolledComposite.setContent(calendarComposite);
		drawIt2();
		//
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				drawIt2();
			}
		});
	}
	public boolean isTempAppointmentIsOverlapping() {
		tempAppointmentIsOverlapping = false;
		for (Iterator iter = timeslots.iterator(); iter.hasNext();) {
			Timeslot el = (Timeslot) iter.next();
			if (el.isTempAppointmentOverLapping()) {
				tempAppointmentIsOverlapping = true;
				break;
			}
		}
		return tempAppointmentIsOverlapping;
	}
	public int getSnapToTime() {
		return snapToTime;
	}
	public void setSnapToTime(int snapToTime) {
		this.snapToTime = snapToTime;
	}
	public void setHeaderBackground(Color headerBackground) {
		this.headerBackground = headerBackground;
	}
	public void setHeaderFont(Font headerFont) {
		this.headerFont = headerFont;
	}
	public void setFont(Font font) {
		this.font = font;
	}
	public void addTempAppointment(Appointment app) {
		// System.out.println("Start temp addAppointment");
		if (isInDay(app)) {
			// System.out.println("Is in day");
			selectedAppointment = app;
			if (timeslots != null) {
				for (Iterator iter = timeslots.iterator(); iter.hasNext();) {
					Timeslot el = (Timeslot) iter.next();
					if (el.isInSlot(app)) {
						el.addTempAppointment(app);
						// System.out.println("Temp Appointment added");
					}
				}
			}
		}
	}
	public void removeTempAppointment() {
		// System.out.println("Start temp removeAppointment");
		if (timeslots != null) {
			for (Iterator iter = timeslots.iterator(); iter.hasNext();) {
				Timeslot el = (Timeslot) iter.next();
				el.removeTempAppointment();
				// System.out.println("Temp Appointment removed");
			}
		}
	}
	public void addAppointmentSelectListener(AppointmentSelectedListener listener) {
		selectListener = listener;
	}
	public void addDateChangedListener(SelectedDateChangedListener listener) {
		dateListener = listener;
	}
	public Color getAppointmentColor() {
		return appointmentColor;
	}
	public void setAppointmentColor(Color appointmentColor) {
		this.appointmentColor = appointmentColor;
	}
	public String getHeader() {
		return header;
	}
	public void setHeader(String header) {
		this.header = header;
		if (this.calendarheader != null) {
			this.calendarheader.setText(header);
		}
	}
	private boolean isInDay(Appointment app) {
		if (app.getStartTime().getTime().equals(date.getTime())
				|| app.getEndTime().getTime().equals(date.getTime())) {
			return true;
		}
		if (app.getStartTime().getTime().after(date.getTime())
				&& app.getEndTime().getTime().before(date.getTime())) {
			return true;
		}
		return true;
	}
	public void addAppointment(Appointment app) {
		// System.out.println("Start addAppointment");
		if (isInDay(app)) {
			// System.out.println("Is in day");
			if (timeslots != null) {
				for (Iterator iter = timeslots.iterator(); iter.hasNext();) {
					Timeslot el = (Timeslot) iter.next();
					if (el.isInSlot(app)) {
						el.addAppointment(app);
						// System.out.println("Appointment added");
					}
				}
			}
		}
	}
	public Calendar getSelectedDate() {
		return selectedDate;
	}
	
	
	public void deleteAllAppointments(){
		for (Iterator iter = currentAppointments.iterator(); iter.hasNext();) {
			Appointment element = (Appointment) iter.next();
			for (Iterator iterator = timeslots.iterator(); iterator.hasNext();) {
				Timeslot ts = (Timeslot) iterator.next();
				ts.removeTempAppointment();
				ts.removeAppointment(element);
				
			}
		}
		currentAppointments.clear();
		drawIt2();
	}
	public void removeAllControls() {
		if (calendarComposite != null) {
			Control[] cons = calendarComposite.getChildren();
			currentAppointments.clear();
			for (int i = 0; i < cons.length; i++) {
				if (cons[i] instanceof Timeslot) {
					Collection timeslotApps = ((Timeslot) cons[i])
							.getCurrentAppointments();
					for (Iterator iter = timeslotApps.iterator(); iter.hasNext();) {
						Appointment el = (Appointment) iter.next();
						if (!currentAppointments.contains(el)){
							currentAppointments.add(el);
						}
					}
					cons[i].dispose();
				}
			}
		}
	}
	public void updateCalendar() {
		drawIt2();
	}
	private void drawIt2() {
		removeAllControls();
		int numOfTimeslots = getNumberOfTimeslots();
		calendarheader.setSize(this.getBounds().width, 30);
		calendarheader.setText(header);
		calendarheader.setFont(headerFont);
		calendarheader.setBackground(SWTResourceManager.getColor(headerBackground
				.getRed(), headerBackground.getGreen(), headerBackground.getBlue()));
		calendarheader.setAlignment(SWT.CENTER);
		calendarComposite.setSize(this.getBounds().width, numOfTimeslots
				* timeslotHeight + 30);
		// System.out.println("Number of timeslots=" + numOfTimeslots);
		// System.out.println("Timeslotheight= " + timeslotHeight);
		int yplace = 30;
		Calendar cal = Calendar.getInstance();
		cal.setTime(date.getTime());
		cal.set(Calendar.HOUR_OF_DAY, startHour);
		cal.set(Calendar.MINUTE, 0);
		timeslots = new ArrayList();
		for (int i = 0; i < numOfTimeslots; i++) {
			final Timeslot timeslot = new Timeslot(calendarComposite, SWT.NONE);
			// timeslot.setTimeslotBackGround(new Color(255, 255, 128));
			timeslot.setLabelLength(labelLength);
			// timeslot.setLabelBackGround(new Color(0, 128, 255));
			timeslot.setBounds(0, yplace, this.getBounds().width, timeslotHeight);
			timeslot.setLabelLength(labelLength);
			Calendar t1 = Calendar.getInstance();
			t1.setTime(cal.getTime());
			timeslot.setStartTime(t1);
			cal.add(Calendar.MINUTE, timeslotLengthInMinutes);
			Calendar t2 = Calendar.getInstance();
			t2.setTime(cal.getTime());
			timeslot.setEndTime(t2);
			timeslot.setLabelText(sim.format(timeslot.getStartTime().getTime()));
			timeslot.setFont(font);
			if (appointmentColor != null) {
				timeslot.setAppointmentColor(appointmentColor);
			}
			// Set alternating colors if specified
			if ((i % 2) == 0) {
				timeslot.setTimeslotBackGround(new Color(timeslot1Color.getRed(),
						timeslot1Color.getGreen(), timeslot1Color.getBlue()));
				timeslot.setLabelBackGround(new Color(label1Color.getRed(), label1Color
						.getGreen(), label1Color.getBlue()));
			} else {
				timeslot.setTimeslotBackGround(new Color(timeslot2Color.getRed(),
						timeslot2Color.getGreen(), timeslot2Color.getBlue()));
				timeslot.setLabelBackGround(new Color(label2Color.getRed(), label2Color
						.getGreen(), label2Color.getBlue()));
			}
			// Add listeners
			timeslot.addDateChangedListener(new SelectedDateChangedListener() {
				public void changeEvent() {
					// Add new appointment
					selectedDate = timeslot.getSelectedTime();
					selectedDate = snapToTime(selectedDate);
					dateListener.changeEvent();
				}
			});
			timeslot.addAppointmentSelectListener(new AppointmentSelectedListener() {
				public void appointmentSelectedEvent(MouseEvent e) {
					selectedAppointment = timeslot.getSelectedAppointment();
					if (selectListener != null) {
						selectListener.appointmentSelectedEvent(e);
					}
				}
			});
			// timeslot.moveAbove(null);
			calendarheader.moveAbove(null);
			timeslots.add(timeslot);
			yplace += timeslotHeight;
		}
		//System.out.println("Appointments size=" + currentAppointments.size());
		for (Iterator iter = currentAppointments.iterator(); iter.hasNext();) {
			Appointment el = (Appointment) iter.next();
			//System.out.println("Appointment " + el.getDescription());
			addAppointment(el);
			
		}
	}
	private Calendar snapToTime(Calendar selectedDate) {
		int minutes = selectedDate.get(Calendar.MINUTE);
		// System.out.println("Minutes before=" + minutes);
		int temp = minutes % snapToTime;
		if (temp > (snapToTime / 2)) {
			temp = minutes / snapToTime + 1;
		} else {
			temp = minutes / snapToTime;
		}
		minutes = temp * snapToTime;
		// System.out.println("Minutes after=" + minutes);
		selectedDate.set(Calendar.MINUTE, minutes);
		return selectedDate;
	}
	public void setLabel1BackGround(Color color) {
		label1Color = color;
	}
	public void setLabel2BackGround(Color color) {
		label2Color = color;
	}
	public void setTimeslot1BackGround(Color color) {
		timeslot1Color = color;
	}
	public void setTimeslot2BackGround(Color color) {
		timeslot2Color = color;
	}
	public int getEndHour() {
		return endHour;
	}
	public void setEndHour(int endHour) {
		this.endHour = endHour;
		drawIt2();
	}
	public int getStartHour() {
		return startHour;
	}
	public void setStartHour(int startHour) {
		this.startHour = startHour;
		drawIt2();
	}
	public int getTimeslotLengthInMinutes() {
		return timeslotLengthInMinutes;
	}
	public void setTimeslotLengthInMinutes(int timeslotLengthInMinutes) {
		this.timeslotLengthInMinutes = timeslotLengthInMinutes;
		drawIt2();
	}
	public Calendar getDate() {
		return date;
	}
	public void setDate(Calendar date) {
		this.date = date;
		this.date.set(Calendar.MINUTE, 0);
		this.date.set(Calendar.HOUR, 0);
		drawIt2();
	}
	private int getNumberOfTimeslots() {
		Calendar temp1 = Calendar.getInstance();
		temp1.setTime(date.getTime());
		temp1.set(Calendar.HOUR_OF_DAY, startHour);
		temp1.set(Calendar.MINUTE, 0);
		Calendar temp2 = Calendar.getInstance();
		temp2.setTime(date.getTime());
		temp2.set(Calendar.HOUR_OF_DAY, endHour);
		temp2.set(Calendar.MINUTE, 0);
		long totalTimeInMinutes = (temp2.getTimeInMillis() - temp1
				.getTimeInMillis()) / 1000 / 60;
		if (timeslotLengthInMinutes == 0) {
			return 1;
		} else {
			return (int) (totalTimeInMinutes / timeslotLengthInMinutes);
		}
	}
	public int getLabelLength() {
		return labelLength;
	}
	public void setLabelLength(int labelLength) {
		this.labelLength = labelLength;
		drawIt2();
	}
	public int getTimeslotHeight() {
		return timeslotHeight;
	}
	public void setTimeslotHeight(int timeslotHeight) {
		this.timeslotHeight = timeslotHeight;
		drawIt2();
	}
	public void dispose() {
		super.dispose();
	}
	protected void checkSubclass() {
	}
	public Appointment getSelectedAppointment() {
		return selectedAppointment;
	}
	public void setDefaultNewAppointmentTimeInMinutes(
			int defaultNewAppointmentTimeInMinutes) {
		this.defaultNewAppointmentTimeInMinutes = defaultNewAppointmentTimeInMinutes;
	}
	public int getDefaultNewAppointmentTimeInMinutes() {
		return defaultNewAppointmentTimeInMinutes;
	}
}
