package za.co.momentum.recurring.nurse.client.ui.components.calendar;

import java.awt.Color;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Iterator;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import za.co.momentum.recurring.nurse.util.TNLogger;
import com.swtdesigner.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class Timeslot extends Composite {
	private final Label timeslotLabelArea;
	private final Label timeslotArea;
	private String labelText;
	private int labelLength;
	private Calendar startTime;
	private Calendar endTime;
	private Calendar selectedTime;
	private Appointment selectedAppointment;
	private Font font;
	private Collection appointments;
	private Appointment tempAppointment;
	private SelectedDateChangedListener listener;
	private AppointmentSelectedListener selectListener;
	private Color appointmentColor;
	private Label[] appointmentLabels;

	public Timeslot(Composite parent, int style) {
		super(parent, style);
		appointments = new ArrayList();
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				updateControls();
			}
		});
		timeslotLabelArea = new Label(this, SWT.HORIZONTAL | SWT.CENTER | SWT.WRAP);
		timeslotLabelArea.setBounds(0, 0, 50, 20);
		timeslotArea = new Label(this, SWT.NONE);
		timeslotArea.addMouseListener(new MouseAdapter() {
			public void mouseDown(MouseEvent e) {
				calculateTime(e.x, e.y);
				listener.changeEvent();
			}
		});
		timeslotArea.setBounds(50, 0, 0, 15);
		updateControls();
		//
	}
	public Color getAppointmentColor() {
		return appointmentColor;
	}
	public void setAppointmentColor(Color appointmentColor) {
		this.appointmentColor = appointmentColor;
	}
	public void addAppointment(Appointment app) {
		if (isInSlot(app)) {
			appointments.add(app);
			updateControls();
		}
	}
	
	public Collection getCurrentAppointments(){
		return appointments;
	}
	public void removeAppointment(Appointment app) {
		appointments.remove(app);
		updateControls();
	}
	public void addTempAppointment(Appointment app) {
		tempAppointment = app;
		addAppointment(app);
	}
	public Appointment getTempAppointment() {
		return tempAppointment;
	}
	public void removeTempAppointment() {
		removeAppointment(tempAppointment);
		tempAppointment = null;
	}
	public void addDateChangedListener(SelectedDateChangedListener listener) {
		this.listener = listener;
	}
	public void addAppointmentSelectListener(AppointmentSelectedListener listener) {
		selectListener = listener;
	}
	public void setStartTime(Calendar slotStartTime) {
		startTime = slotStartTime;
	}
	public Calendar getStartTime() {
		return startTime;
	}
	public void setEndTime(Calendar slotEndTime) {
		endTime = slotEndTime;
	}
	public Calendar getEndTime() {
		return endTime;
	}
	public void setLabelBackGround(Color color) {
		timeslotLabelArea.setBackground(SWTResourceManager.getColor(color.getRed(),
				color.getGreen(), color.getBlue()));
	}
	public void setTimeslotBackGround(Color color) {
		timeslotArea.setBackground(SWTResourceManager.getColor(color.getRed(),
				color.getGreen(), color.getBlue()));
	}
	public int getLabelLength() {
		return labelLength;
	}
	public void setLabelLength(int labelLength) {
		this.labelLength = labelLength;
	}
	public String getLabelText() {
		return labelText;
	}
	public void setLabelText(String labelText) {
		this.labelText = labelText;
		timeslotLabelArea.setText(labelText);
	}
	private void updateControls() {
		timeslotLabelArea.setBounds(0, 0, labelLength, this.getSize().y);
		timeslotArea.setBounds(labelLength + 1, 0, this.getSize().x - labelLength,
				this.getSize().y);
		drawAppointments();
	}
	public boolean isTempAppointmentOverLapping() {
		if (tempAppointment == null) {
			return false;
		}
		Appointment app = tempAppointment;
		for (Iterator iter = appointments.iterator(); iter.hasNext();) {
			Appointment el = (Appointment) iter.next();
			if ((app.getStartTime().getTime().after(el.getStartTime().getTime()))
					&& (app.getStartTime().getTime().before(el.getEndTime().getTime()))) {
				return true;
			}
			if ((app.getEndTime().getTime().after(el.getStartTime().getTime()))
					&& (app.getEndTime().getTime().before(el.getEndTime().getTime()))) {
				return true;
			}
			if ((app.getStartTime().getTime().before(el.getStartTime().getTime()))
					&& (app.getEndTime().getTime().after(el.getEndTime().getTime()))) {
				return true;
			}
		}
		return false;
	}
	public boolean isInSlot(Appointment app) {
		if (app.getStartTime().getTime().equals(startTime.getTime())
				|| app.getStartTime().getTime().equals(endTime.getTime())) {
			return true;
		}
		if (app.getStartTime().getTime().after(startTime.getTime())
				&& app.getStartTime().getTime().before(endTime.getTime())) {
			return true;
		}
		if (app.getEndTime().getTime().equals(startTime.getTime())
				|| app.getEndTime().getTime().equals(endTime.getTime())) {
			return true;
		}
		if (app.getEndTime().getTime().after(startTime.getTime())
				&& app.getEndTime().getTime().before(endTime.getTime())) {
			return true;
		}
		if (app.getStartTime().getTime().before(startTime.getTime())
				&& app.getEndTime().getTime().after(endTime.getTime())) {
			return true;
		}
		return false;
	}
	private void removeAllAppointments() {
		if (appointmentLabels != null) {
			for (int i = 0; i < appointmentLabels.length; i++) {
				appointmentLabels[i].dispose();
			}
		}
	}
	private void drawAppointments() {
		removeAllAppointments();
		//System.out.println("Timeslot appointments size " + appointments.size());
		if (appointments == null || endTime == null || startTime == null) {
			return;
		}
		long endMinutes = endTime.getTimeInMillis() / 1000 / 60;
		long startMinuts = startTime.getTimeInMillis() / 1000 / 60;
		long slotLength = endMinutes - startMinuts;
		double y = this.getSize().y;
		double sl = slotLength;
		double pixelValue = sl / y;
		appointmentLabels = new Label[appointments.size()];
		int i = 0;
		
		for (Iterator iter = appointments.iterator(); iter.hasNext(); i++) {
			final Appointment el = (Appointment) iter.next();
			if (isInSlot(el)) {
				long minutesToAdd = (el.getStartTime().getTimeInMillis() / 1000 / 60)
						- startMinuts;
				//System.out.println("Adding appointment");
				Double mouseY = new Double(minutesToAdd / pixelValue);
				Long yLength = new Long((el.getEndTime().getTimeInMillis() / 1000 / 60)
						- (el.getStartTime().getTimeInMillis() / 1000 / 60));
				appointmentLabels[i] = new Label(this, SWT.NONE);
				// System.out.println("Mouse y value= " + mouseY.intValue());
				appointmentLabels[i].setLocation(labelLength + 1, mouseY.intValue());
				SimpleDateFormat sim = new SimpleDateFormat("HH:mm");
				appointmentLabels[i].setText(el.getDescription() + "\n"
						+ el.getSuburb() + "\n" + el.getAppLocation() + "\n Time:"
						+ sim.format(el.getStartTime().getTime()) + " to "
						+ sim.format(el.getEndTime().getTime()));
				if (appointmentColor == null) {
					appointmentColor = Color.WHITE;
				}
				appointmentLabels[i].setBackground(SWTResourceManager.getColor(
						appointmentColor.getRed(), appointmentColor.getGreen(),
						appointmentColor.getBlue()));
				if ((mouseY.intValue() + yLength.intValue()) > timeslotArea.getSize().y) {
					appointmentLabels[i].setSize(this.getSize().x - labelLength,
							timeslotArea.getBounds().height - mouseY.intValue());
				} else {
					appointmentLabels[i].setSize(this.getSize().x - labelLength,
							new Double(yLength.intValue() * y / sl).intValue());
				}
				appointmentLabels[i].moveAbove(null);
				appointmentLabels[i].setCursor(SWTResourceManager
						.getCursor(SWT.CURSOR_HAND));
				appointmentLabels[i].setToolTipText(el.getDescription() + "\n"
						+ "Start time: " + sim.format(el.getStartTime().getTime())
						+ "\nEnd time: " + sim.format(el.getEndTime().getTime())
						+ "\nLocation: " + el.getAppLocation());
				// Add listener
				appointmentLabels[i].addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent e) {
						if (selectListener != null) {
							selectedAppointment = el;
							selectListener.appointmentSelectedEvent(e);
						}
					}
				});
			}
		}
	}
	public void bringAppsToFront() {
		//drawAppointments();
	}
	private void calculateTime(int mouseX, int mouseY) {
		long endMinutes = endTime.getTimeInMillis() / 1000 / 60;
		long startMinuts = startTime.getTimeInMillis() / 1000 / 60;
		long slotLength = endMinutes - startMinuts;
		double y = this.getSize().y;
		double sl = slotLength;
		double pixelValue = sl / y;
		int minutesToAdd = (int) (mouseY * pixelValue);
		Calendar date = Calendar.getInstance();
		date.setTime(startTime.getTime());
		date.add(Calendar.MINUTE, minutesToAdd);
		// System.out.println("Timeslot selected date ="
		// + new SimpleDateFormat("yyyy/MM/dd HH:mm").format(date.getTime()));
		selectedTime = date;
	}
	public void dispose() {
		super.dispose();
	}
	protected void checkSubclass() {
	}
	public Calendar getSelectedTime() {
		return selectedTime;
	}
	public Font getFont() {
		return font;
	}
	public void setFont(Font font) {
		this.font = font;
		timeslotLabelArea.setFont(font);
		timeslotArea.setFont(font);
	}
	public Appointment getSelectedAppointment() {
		return selectedAppointment;
	}
}
