package za.co.momentum.recurring.nurse.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

// Author: Johan H <johan@guruhut.com>

public class ConnectionManager {
	private static boolean initialized = false;
	//private static final String JDBC_URL = "jdbc:hsqldb:file:c:/application_data.db";
	private static String JDBC_URL = null;
	private static String DB_USER = null;
	private static String DB_PASS = null;
	
	public static void main(String[] args) {
		Connection c = null;
		try {
			c = ConnectionManager.getConnection();
		} catch (SQLException e) {
			
			e.printStackTrace();
		} finally {
			ConnectionManager.cleanup(c);
		}
	}
	
	private ConnectionManager instance = null;
	static {
		try {
			Class.forName("org.hsqldb.jdbcDriver");
		} catch (ClassNotFoundException e) {
			throw new RuntimeException("Failed to load hypersonic jdbc driver... Very serious... Stop dead now", e );
		}
		JDBC_URL = DbPropertyManager.getInstance().getJdbcUrl();
		DB_USER = DbPropertyManager.getInstance().getJdbcUser();
		DB_PASS = DbPropertyManager.getInstance().getJdbcPass();
		initialized = true; // Crude but effective.
	}
	public static void debug() {
		//System.out.println("JDBC_URL " + JDBC_URL);
		//System.out.println("DB_USER " + DB_USER);
		//System.out.println("DB_PASS " + DB_PASS);
	}
	public static Connection getConnection() throws SQLException {
		//TNLogger.debug("In ConnectionManager.getConnection");
		howlIfNotInitialized();
		
		Connection conn = DriverManager.getConnection(JDBC_URL, DB_USER, DB_PASS);
		//TNLogger.debug("Return connection " + conn);
		return conn;
	}
	private static void howlIfNotInitialized() {
		if (!initialized) {
			throw new RuntimeException("FATAL ERROR:  Hypersonic driver did not initialize... Cannot continue");
		}
	}
	public static void cleanup(Connection conn) {
		try { if (conn != null) conn.close(); } catch (SQLException e) {}
	}
	public static void cleanup(ResultSet rs) {
		try { if (rs != null) rs.close(); } catch (SQLException e) {}
	}
	public static void cleanup(PreparedStatement ps) {
		try { if (ps != null) ps.close(); } catch (SQLException e) {}
	}
	public static void cleanup(Connection conn, PreparedStatement ps, ResultSet rs) {
		cleanup(rs); cleanup(ps); cleanup(conn);
	}
	public static void cleanup (Connection conn, PreparedStatement ps) {
		cleanup(ps); cleanup(conn);
	}
	public static void cleanup(Connection conn, ResultSet rs) {
		cleanup(rs); cleanup(conn);
	}
}
