package za.co.momentum.recurring.nurse.db;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.Collection;


// Author: Johan H <johan@guruhut.com>
public abstract class ReverseMapped {

	protected static String getTextForConstant(Class clazz, int const_value) throws IllegalArgumentException {
		
		Field [] fields = clazz.getDeclaredFields();
		int i = 0;
		for (i = 0; i < fields.length; i++) {
			Field field = fields[i];
			try {
				if (field.getInt(field) == const_value) {
					break;
				}
			} catch (IllegalAccessException e) {} // Does not matter, try next field
		}
		if (i == fields.length) {
			throw new IllegalArgumentException ("Could not match const_value to a field");
		}
		return fields[i].getName();
	}
	
	protected static int[] getAllConstants(Class clazz) {
		
		Field [] fields = clazz.getDeclaredFields();
		int i = 0;
		ArrayList c = new ArrayList();
		for (i = 0; i < fields.length; i++) {
			Field field = fields[i];
			int m = field.getModifiers();
			if ( Modifier.isStatic(m) && Modifier.isPublic(m) && Modifier.isFinal(m)) {
				if (field.getType().toString().equals("int")) {
					if (field.getName().equals(field.getName().toUpperCase())) {
						try {
							c.add(new Integer(field.getInt(field)));
						} catch (IllegalAccessException e) {} // If we cant access it, we should not be using it as a constant.
					}
				}
			}
		}
		int [] returnints = new int [c.size()];
		for (int j = 0; j < c.size(); j++) {
			returnints[j] = ((Integer)(c.get(j))).intValue(); // YeeHaw
		}
		return returnints;
	}

}
