package za.co.momentum.recurring.nurse.db;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.StringTokenizer;


// Author: Johan H <johan@guruhut.com>
// Extending ConnectionManager to provide easy access to Connections and related functions.

public class SchemaManager extends ConnectionManager {
	private static volatile boolean initialized = false;
	private static void initializeSchema(Connection conn) throws SQLException, ClassNotFoundException {
		// Build the database.
		
		
//		for (Iterator i = DbPropertyManager.getInstance().getFilesToCreate().iterator(); i.hasNext();) {
//			executeSQL(conn, (String)i.next());
//		}
//		
		
		
	}
	private static void loadConstants(Connection conn) throws SQLException, ClassNotFoundException {
		
//		for (Iterator i = DbPropertyManager.getInstance().getAutoLoad().iterator(); i.hasNext();) {
//			String s = (String)i.next();
//			AutoClass ac = getClassDetails(s);
//			String sql = "insert into " + ac.table + "(id, desc) values(?, ?)";
//			PreparedStatement ps = conn.prepareStatement(sql);
//			
//			PreparedStatement readPs = conn.prepareStatement("select count(1) from " + ac.table + " where id = ?");
//			Class c = Class.forName(ac.clazz);
//			
//			// Deep magik...
//			int [] ii = ReverseMapped.getAllConstants(c);
//			for (int j = 0; j < ii.length; j++) {
//				int cnst = ii[j];
//				String v = ReverseMapped.getTextForConstant(c, cnst);
//				
//				readPs.setInt(1, cnst);
//				ResultSet rs = readPs.executeQuery();
//				if (rs.next()) {
//					if (rs.getInt(1) > 0 ) {
//						//System.out.println("Ignoreing duplicate : " + v);
//						continue;
//					}
//				}
//				ps.setInt(1, cnst);
//				ps.setString(2, v);
//				ps.executeUpdate(); // Need to deal with dups here...
//			}
//			cleanup(ps);
//			cleanup(readPs);
//			
//		}
	}
	
	public static void loadConstantsFromClasses() throws SQLException, ClassNotFoundException {
		Connection c = null;
		try {
			c = getConnection();
			loadConstants(c);
		} finally {
			cleanup(c);
		}
	}
	private static void dropTables(Connection conn) throws SQLException {
//		for (Iterator i = DbPropertyManager.getInstance().getFilesToDrop().iterator(); i.hasNext();) {
//			executeSQL(conn, (String)i.next());
//		}
	}
	
	public static synchronized void dropSchema() throws SQLException {
		Connection c = null;
		try {
			c = getConnection();
			dropTables(c);
		} finally {
			cleanup(c);
		}
	}
	
	public static synchronized void initializeNew() throws SQLException, ClassNotFoundException {
		throwUpIfAlreadyInitialized();
		Connection c = null;
		try {
			c = getConnection();
			try { dropTables(c); } catch (Exception e) {};
			initializeSchema(c);
			loadConstants(c);
		} finally {
			cleanup(c);
		}
	}
	private static void executeSQL(Connection conn, String sql) throws SQLException {
		PreparedStatement ps = conn.prepareStatement(sql);
		ps.executeUpdate();
		cleanup(ps);
	}
	
	private static void throwUpIfAlreadyInitialized() {
		if (initialized) {
			throw new RuntimeException("Trying to initialize schema more than once... Most likely a bug");
		}
		initialized = true;
	}
	private static AutoClass getClassDetails(String p) {
		AutoClass ac = new AutoClass();
		StringTokenizer st = new StringTokenizer(p, ",");
		
		ac.table = st.nextToken();
		ac.clazz = st.nextToken();
		
		return ac;
	}
	static class AutoClass {
		String clazz;
		String table;
	}
}
