package za.co.momentum.recurring.nurse.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.StaxDriver;

public class Serializer {
	public static byte[] serialize(Object object) {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		ObjectOutput out = null;
		try {
			out = new ObjectOutputStream(bos);
			out.writeObject(encode(object));			
			byte[] byteArray = bos.toByteArray();
            return byteArray;
		} catch (IOException e) {
	        e.printStackTrace();
	        return null;
	    } finally {
	        try {
	            if (out != null)
	                out.close();
	        } catch (IOException ex) {
	        }
	        try {
	            bos.close();
	        } catch (IOException ex) {
	        }
	    }
	}
	
	public static Object deserialize(byte[] byteArray) {
        ByteArrayInputStream bis = new ByteArrayInputStream(byteArray);
        ObjectInput in = null;
        try {
            in = new ObjectInputStream(bis);
            byte[] o = (byte[]) in.readObject();
            return decode(o);
        } catch (ClassNotFoundException cnfe) {
            cnfe.printStackTrace();
            return null;
        } catch (IOException ioe) {
        	ioe.printStackTrace();
            return null;
        } finally {
            try {
                bis.close();
            } catch (IOException ex) {
            }
            try {
                if (in != null)
                    in.close();
            } catch (IOException ex) {
            }
        }
    }
	
	public static Object decode(byte[] ba) {
		return new XStream(new StaxDriver()).fromXML(new String(ba));
	}
	
	public static byte[] encode(Object object) {
		return new XStream(new StaxDriver()).toXML(object).getBytes();
	}
}
