package za.co.momentum.recurring.nurse.util.anttasks;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.StringTokenizer;
import org.apache.tools.ant.BuildException;

public class ChangeClassPackageAndName extends org.apache.tools.ant.Task {
	// Semicolon delimited string of files to change name and package
	private String classFiles;
	private String newClassNames;
	private String newPackages;

	public String getClassFiles() {
		return classFiles;
	}

	public void setClassFiles(String classFiles) {
		this.classFiles = classFiles;
	}

	public String getNewClassNames() {
		return newClassNames;
	}

	public void setNewClassNames(String newClassNames) {
		this.newClassNames = newClassNames;
	}

	public String getNewPackages() {
		return newPackages;
	}

	public void setNewPackages(String newPackages) {
		this.newPackages = newPackages;
	}

	public void execute() throws BuildException {
		StringTokenizer st = new StringTokenizer(classFiles, ";");
		StringTokenizer names = new StringTokenizer(newClassNames, ";");
		StringTokenizer packages = new StringTokenizer(newPackages, ";");
		while (st.hasMoreTokens()) {
			String filename = st.nextToken();
			String className = names.nextToken();
			String thePackage = packages.nextToken();
			BufferedWriter outFile = null;
			BufferedReader f1 = null;
			try {
				System.out.println("File name: " + filename);
				
				f1 = new BufferedReader(new FileReader(filename));

				outFile = new BufferedWriter(new FileWriter(filename + "tmp"));
				while (f1.ready()) {
					String temp = f1.readLine();
					if (temp.indexOf("package") >= 0) {
						outFile.write("package " + thePackage + ";");
					} else if (temp.indexOf("public interface") >= 0) {
						String originalClassname = temp.substring(temp.indexOf(" ", temp
								.indexOf("interface") + 1), temp.indexOf(" ", temp
								.indexOf("interface") + 10));
						String t = temp.substring(temp.indexOf(originalClassname)
								+ originalClassname.length());
						outFile.write("public interface " + className + t);
					} else {
						outFile.write(temp);
					}
					outFile.write("\n");
				}
				f1.close();
				outFile.flush();
				outFile.close();
				renameFiles(filename + "tmp", filename);
			} catch (IOException e) {
				e.printStackTrace();
				System.out.println("Error " + e.getMessage());
			}
		}
	}

	private void renameFiles(String oldFile, String newFile) {
		File old = new File(oldFile);
		File f = new File(newFile);
		if (f.exists()) {
			f.renameTo(new File(f.getAbsolutePath()
					+ Calendar.getInstance().getTimeInMillis()));
		}
		old.renameTo(new File(newFile));
	}
}
